;
;   MASMWIN.ASM
;   Brian Lieuallen
;   Copyright (c) 1991 Microsoft Corporation. All rights reserved.
;
;  TASM version and enhancements By D. Lindauer

.model    large, WINDOWS PASCAL
.286
.287

jumps
include  windows.inc

	public WndProc,AboutBoxProc
extrn 	INITTASK : PROC
extrn	WAITEVENT : PROC
extrn	INITAPP : PROC
extrn	LOADICON : PROC
extrn 	LOADCURSOR : PROC
extrn	GETSTOCKOBJECT : PROC
extrn	REGISTERCLASS : PROC
extrn	CREATEWINDOW : PROC
extrn	UPDATEWINDOW : PROC
extrn	SHOWWINDOW:PROC
extrn	GETMESSAGE : PROC
extrn	TRANSLATEMESSAGE : PROC
extrn	DISPATCHMESSAGE : PROC
extrn	SETTIMER : PROC
extrn 	SETWINDOWTEXT : PROC
extrn	BEGINPAINT : PROC
extrn	ENDPAINT : PROC
extrn	MAKEPROCINSTANCE : PROC
extrn	DIALOGBOX : PROC
extrn	FREEPROCINSTANCE : PROC
extrn	POSTQUITMESSAGE : PROC
extrn	DEFWINDOWPROC : PROC
extrn	ENDDIALOG : PROC
extrn	TEXTOUT : PROC
extrn	INVALIDATERECT : PROC
extrn   SHOWWINDOW : PROC
extrn   BRINGWINDOWTOTOP : PROC

ID_ICON     equ   1000

.data
localheaphead   db  16 dup (?)	; need be in heap seg for heap alloc
hInstance	dw	?
hPrevInstance	dw	?
lpszCmdParam	dd	?
nCmdShow	dw	?
psp		dw	?

szAscii	    db   '! is the character',0
MSG_L = ($-szascii)
szaltAppName db  'TasmAltWin',0
salttitle	    db   'Example of drawing to an alternate window',0
szAppName   db   'TasmWin',0
stitle	    db   'A windows program in TASM',0
string1     db   'Tasm is great',0
string2     db   'C is for wimps',0
about       db   'ABOUT',0
menuname    db   'GenericMenu',0
flag        dw   0
hwnd	    dw   ?
lpProcAbout dd  ?
msgx	MSGSTRUCT ?
wc	WNDCLASS ?
althwnd	    dw   ?

.code

start	PROC
                mov     ax, @data
                mov     ds, ax           ; set up data segment

;Windows initialization.  Sets up registers and stack.

                ;INITTASK returns:
                ;  Failure:
                ;    AX = zero if it failed
                ;  Success:
                ;    AX = 1
                ;    CX = stack limit
                ;    DX = cmdShow parameter to CreateWindow
                ;    ES:BX = -> DOS format command line (ES = PSP address)
                ;    SI = hPrevinstance
                ;    DI = hinstance

                call    INITTASK
                or      ax,ax
                jnz     @@OK
                jmp     @@Fail
@@OK:           mov     [psp],es
                mov     word ptr [lpszCmdParam],bx
                mov     [hPrevInstance],si
                mov     [hInstance],di
                mov     [nCmdShow],dx

;Initialize the Windows App

                call    WAITEVENT,0
                call    INITAPP,[hInstance]
                or      ax,ax
                jnz     @@InitOK

@@Fail:
                mov     ax, 4CFFh
                int     21h          ; terminate program


@@InitOK:
;-----------------------------------------------------------------------------
; This is generally where WinMain is called.  We won't use a WinMain, since
;  this app is 100% assembly.

          cmp      hPrevInstance,0
          jne      dontregister

          mov      wc.clsstyle, CS_HREDRAW + CS_VREDRAW

          mov      word ptr wc.clslpfnWndProc,   offset WndProc
          mov      word ptr wc.clslpfnWndProc+2, seg    WndProc

          mov      wc.clscbClsExtra,0
          mov      wc.clscbWndExtra,0

          mov      ax,hInstance
          mov      wc.clshInstance,ax

          call	   LOADICON, ax, ID_ICON
          mov      wc.clshIcon,ax

          call     LOADCURSOR, 0,IDC_ARROW
          mov      wc.clshCursor,ax

          call     GETSTOCKOBJECT,WHITE_BRUSH
          mov      wc.clshbrBackground,ax

          mov      word ptr wc.clslpszMenuName,  offset menuname
          mov      word ptr wc.clslpszMenuName+2,ds

          mov      word ptr wc.clslpszClassName, offset szAppName
          mov      word ptr wc.clslpszClassName+2, ds

          call     REGISTERCLASS,ds,offset wc

          or       ax,ax
          je       progexit

          mov      wc.clsstyle, CS_HREDRAW + CS_VREDRAW

          mov      word ptr wc.clslpfnWndProc,   offset AltWndProc
          mov      word ptr wc.clslpfnWndProc+2, seg    AltWndProc

          mov      wc.clscbClsExtra,0
          mov      wc.clscbWndExtra,0

          mov      ax,hInstance
          mov      wc.clshInstance,ax

          call	   LOADICON, ax, ID_ICON
          mov      wc.clshIcon,ax

          call     LOADCURSOR, 0,IDC_ARROW
          mov      wc.clshCursor,ax

          call     GETSTOCKOBJECT,WHITE_BRUSH
          mov      wc.clshbrBackground,ax

          mov      word ptr wc.clslpszMenuName,  0
          mov      word ptr wc.clslpszMenuName+2,0

          mov      word ptr wc.clslpszClassName, offset szaltAppName
          mov      word ptr wc.clslpszClassName+2, ds

          call     REGISTERCLASS,ds,offset wc

          or       ax,ax
          je       progexit

dontregister:

          call     CREATEWINDOW, DS, offset szAppName, \
         			 DS, offset stitle,      \
                                 WS_OVERLAPPEDWINDOW + WS_VISIBLE,    \
				 0,      \
                                 300,                  \
                                 300,                  \
                                 200,                  \
                                 200,                  \
                                 0,                           \
                                 0,                            \
                                 hInstance,                     \
                                 0,0

          or       ax,ax
          je       progexit
          mov      hwnd,ax
          call     CREATEWINDOW, DS, offset szaltAppName, \
         			 DS, offset salttitle,      \
                                 WS_DLGFRAME + WS_VISIBLE,    \
				 0,      \
                                 50,                  \
                                 50,                  \
                                 200,                  \
                                 200,                  \
                                 0,                           \
                                 0,                            \
                                 hInstance,                     \
                                 0,0

          or       ax,ax
          je       progexit
          mov      althwnd,ax

          call     SHOWWINDOW,hwnd,nCmdShow
          call     UPDATEWINDOW,hwnd
          call     SHOWWINDOW,althwnd,nCmdShow
          call     UPDATEWINDOW,althwnd

messageloop:
          call     GETMESSAGE,ds, offset msgx ,0,0,0
          test     ax,ax
          je       progexit

          call     TRANSLATEMESSAGE,ds,offset msgx
          call     DISPATCHMESSAGE,ds,offset msgx
          jmp      short  messageloop

progexit:
                 mov    ax, [msgx.msWPARAM]
                 mov    ah, 4Ch
                 int    21h
start     endp




WndProc   PROC uses si di, wphwnd :word, wpmsg :WORD, wParam  :WORD, lParam  :DWORD

          LOCAL    hdc :word, ps  :PAINTSTRUCT

          mov      ax,wpmsg

          cmp      ax,WM_CREATE
          jne      wp1

            call     SETTIMER,wphwnd,1,1000,0 ,0
            jmp      wpReturn0


wp1:       cmp      ax,WM_TIMER
          jne      wp2

            cmp      wParam,1
            jne      wpReturn0

            test     flag,-1
            jne      settext1

            call     SETWINDOWTEXT,wphwnd,DS, offset string1
            not      flag
            jmp      wpReturn0
settext1:
            call     SETWINDOWTEXT,wphwnd,DS, offset string2
            not      flag
	    call	INVALIDATERECT,[althwnd],0,0,0
            jmp      wpReturn0


wp2:
	    cmp ax,WM_ACTIVATE
	    jne wp2a
	    test word ptr [lparam+2],-1
	    jnz ishidden
            call SHOWWINDOW,althwnd,SW_SHOW
	    jmp wpReturn0
ishidden:
            call SHOWWINDOW,althwnd,SW_HIDE
	    jmp wpReturn0

wp2a:

       cmp      ax,WM_PAINT
          jne      wp3

	  lea	bx,[ps]
            call     BEGINPAINT,wphwnd,ss,bx
            mov      hdc,ax

	  lea	bx,[ps]
            call     ENDPAINT,wphwnd,ss,bx
            jmp      wpReturn0


wp3:       cmp      ax,WM_KEYDOWN
          jne      wp4

            jmp    wpReturn0


wp4:       cmp      ax,WM_COMMAND
          jne      wp5
            cmp      wParam,200
            jne      wp5
            call     MAKEPROCINSTANCE, cs,offset AboutBoxProc,hInstance
            mov      word ptr lpProcAbout,ax
            mov      word ptr lpProcAbout+2,dx
            call     DIALOGBOX,hInstance,DS,offset about,wphwnd,lpProcAbout
            call     FREEPROCINSTANCE,lpProcAbout
            jmp      wpReturn0


wp5:       cmp      ax,WM_DESTROY
          jne      wp6
            call     POSTQUITMESSAGE,0
            jmp      wpReturn0


wp6:       call     DEFWINDOWPROC,wphwnd,wpmsg,wParam,lParam
          jmp      wbprocend

wpReturn0:
          xor      ax,ax
          mov      dx,ax
wbprocend:
          ret
WndProc   ENDP
altWndProc   PROC uses si di, wphwnd :word, wpmsg :WORD, wParam  :WORD, lParam  :DWORD

          LOCAL    hdc :word, ps  :PAINTSTRUCT
	mov ax,[wpmsg]
          cmp      ax,WM_CREATE
          je      awp0
       cmp      ax,WM_DESTROY
          jne      awppaint
            call     POSTQUITMESSAGE,0
            jmp      awp0
awppaint:
	       cmp      ax,WM_PAINT
          jne      awpd

		call	BRINGWINDOWTOTOP,wphwnd
	  lea	bx,[ps]   
            call     BEGINPAINT,wphwnd,ss,bx
            mov      [hdc],ax

          call    TEXTOUT,[hDC],10,10,ds,offset szascii, MSG_L
	  inc [szascii]

	  lea	bx,[ps]
            call     ENDPAINT,wphwnd,ss,bx
awp0:
	    sub	ax,ax
	    sub dx,dx
            jmp      awpx
awpd:
          call     DEFWINDOWPROC,wphwnd,wpmsg,wParam,lParam
awpx:
          ret
altWndProc   ENDP

AboutBoxProc   PROC uses si di, abhwnd:word, abmsg :WORD, wParam  :WORD, lParam  :DWORD
          mov      ax,abmsg

          cmp      ax,WM_INITDIALOG
          jne      ap0

            jmp      abreturn0

ap0:       cmp      ax,WM_COMMAND
          jne      ap1

            mov      ax,wParam
            cmp      ax,100
            jne      abreturn0

              call    ENDDIALOG,abhwnd,1
              mov     ax,1
              jmp     abprocend


ap1:
abreturn0:
          xor      ax,ax
          mov      dx,ax
abprocend:
          ret


AboutBoxProc   ENDP

          end	start