;-----------------------------------------
;   SINEWAVE.asm -- Sine Wave Using Polyline
;   based on Charles Petzold's SINEWAVE.C
;   Translated into assembly 31/3/99 by
;   Ron Thomas Ron_Thom@Compuserve.com	
;-----------------------------------------
include windows.inc
include math.inc

includelib user32.lib
includelib kernel32.lib
includelib winmm.lib
includelib gdi32.lib

SND_FILENAME = 020000h		; name is filename (from WIN32def.equ)
SND_ASYNC    = 01h		; play asynchronously(	"	"    )	  
     	
PlaySound	PROTO	STDCALL pszSound:DWORD, hmod:DWORD, fdwSound:DWORD
Polyline	PROTO	STDCALL hdc:DWORD, apt:LPPOINT,	num:DWORD

.387

.data
ClassName db "SimpleWinClass",0
AppName   db "Sine Wave Using Polyline",0
OurText   db "This is a Sine Wave",0
Play	  db "HelloWin.wav",0

cxClient	SDWORD	?	; Can't use Locals; Refuses to recognise computed values !  
cyClient	SDWORD	?	;

NUM	DD	1000
TWOPI	REAL8	6.28318
temp	DD	?
 
apt	POINT 1000 DUP ({?})	; 1000 pairs of DWORD coordinates (x,y) 

PUBLIC	exp@8			;*** Fudge to remove LNK 2001 error unresolved ref _exp@8 ***
exp@8	dw	?

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
        LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
        push  hInstance
        pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax 
        invoke RegisterClassEx, addr wc
        INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
        mov   hwnd,eax
        INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
        INVOKE UpdateWindow, hwnd
        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
        .ENDW
        mov     eax,msg.wParam
        ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        LOCAL hdc:HDC
        LOCAL ps:PAINTSTRUCT
        LOCAL rect:RECT

	mov   eax,uMsg

	.IF eax==WM_CREATE
		invoke PlaySound, ADDR Play, NULL, SND_FILENAME or SND_ASYNC ;Play wave file 

	.ELSEIF eax==WM_SIZE

	mov	ebx,lParam
	mov	cxClient,ebx		; Set to low word
	and	cxClient,0FFFFh 

	shr	ebx,17			; Shift 16 for high word plus extra shift to 	
	mov	cyClient,ebx		; set cyClient to midframe 
						
	.ELSEIF eax==WM_DESTROY
		invoke PostQuitMessage,NULL
        .ELSEIF eax==WM_PAINT
                invoke BeginPaint,hWnd, ADDR ps
                mov    hdc,eax
		invoke MoveToEx, hdc, 0, cyClient, NULL	; Set start point
		invoke LineTo, hdc, cxClient, cyClient	; Draw horizontal axis  

		fninit
		mov	ecx,NUM
		mov	ebx,0
	looppt:	mov	temp,ecx		; get loop index
		fild	temp			; st = i
	;	fild	dword ptr [esi]		; If used instead of above, get illegal op
 		fidiv	NUM			; st = i/NUM

		fild	cxClient		; st=cxClient, i/NUM 
		fmul	st,st(1)		; i*cxClient/NUM, i/NUM
		fistp	apt[ebx].x		; Set x coord, leaving st=i/NUM
		
		fmul	TWOPI			; st=2Pi*i/NUM
		fsin				; st=sine(2*Pi*i/NUM)				
		fld1				; st=1.0, st(1)=sine(2*Pi*i/NUM)
		fsubr				; st=(1.0 - sine(2*Pi*i/NUM) )

		mov	esi,cyClient		; cyClient has already been halved (for axis) 

		mov	temp,esi
		fimul	temp			; st=(cyClient/2)*(1-sin(2*Pi*i/NUM) )	
	;	fmul	dword ptr [esi]		; If used instead of above, get illegal op 	
		fistp	apt[ebx].y		; Set y coord
		
		add	ebx,8			; Bump to next pair of coords
		loop	looppt			; Compute all coordinates

		invoke	Polyline, hdc, ADDR apt, NUM	; Draw sinewave with NUM points 	 

                invoke GetClientRect,hWnd, ADDR rect
                invoke DrawText, hdc,ADDR OurText,-1, ADDR rect, DT_SINGLELINE or DT_CENTER or DT_VCENTER
                invoke EndPaint,hWnd, ADDR ps
        .ELSE
                invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                ret
	.ENDIF
        xor    eax,eax
	ret

WndProc endp
        end start

