ideal
p386n
model flat, stdcall

udataseg

NOWINERROR	= 0
NODDE		= 0
NOMMSYSTEM	= 0
NOWINSPOOL	= 0
include "windows.inc"
include "clouds.inc"

Message 	MSG ?
hwndTabControl	dd ?
label TabWindows
hwndCloud	dd ?
hwndPalette	dd ?
hwndAbout	dd ?

RedPoints	db 2 * MAXPOINTS dup (?)
GreenPoints	db 2 * MAXPOINTS dup (?)
BluePoints	db 2 * MAXPOINTS dup (?)

BitmapInfoHdr	BITMAPINFOHEADER ?
palEntries	dd 256 dup (?)

PalBitmap	db 256 dup (?)
CloudBmp	db 257*257 dup (?)

szFile		db MAXFILENAMELEN dup (?)

struc	LOADAREASTR
	Signature	dd ?
	Seed		dd ?
	Density 	db ?
	Tile		db ?
	NumRedPoints	db ?
	NumGreenPoints	db ?
	NumBluePoints	db ?
	Points		db 2*3*MAXPOINTS dup (?)
ends

LoadArea	LOADAREASTR ?

dataseg

szAppName	db 'Fractal Clouds', 0
szTabControl	db WC_TABCONTROL
szCloud 	db 'Cloud', 0
szPalette	db 'Palette', 0
szAbout 	db 'About', 0
szCloudClass	db 'cls_cloud', 0
szChartClass	db 'cls_chart', 0
szPaletteClass	db 'cls_palette', 0
szRed		db 'Red', 0
szGreen 	db 'Green', 0
szBlue		db 'Blue', 0
szOpenError	db 'Error loading file', 0
szSaveError	db 'Error saving file', 0
szError 	db 'Error', 0

MainClass	WNDCLASS <CS_HREDRAW+CS_VREDRAW, O MainWndProc, 0, 0, 0, 0, 0,\
			  COLOR_3DFACE+1, 0, O szAppName>
CloudClass	WNDCLASS <CS_HREDRAW+CS_VREDRAW, O CloudWndProc, 0, 0, 0, 0, 0,\
			  0, 0, O szCloudClass>
ChartClass	WNDCLASS <CS_HREDRAW+CS_VREDRAW, O ChartWndProc, 0, 0, 0, 0,\
			  0, 0, 0, O szChartClass>
PaletteClass	WNDCLASS <CS_HREDRAW+CS_VREDRAW, O PaletteWndProc, 0, 0, 0, 0,\
			  0, 0, 0, O szPaletteClass>
hInstance	= MainClass.hInstance

Flags		db flagToCreate + flagWrap
GlobalSeed	dd 0
Seed		dd 1
Density 	dd 20

Fractal 	dd FracWrap

PointSelected	db 0
PointsAddr	dd O RedPoints
NumPoints	dd 2

NumRedPoints	db 2
NumGreenPoints	db 2
NumBluePoints	db 2

Chart1Is	db 0
Chart2Is	db 1
Chart3Is	db 2

CloudWndNotify	dd _ReturnFalse, _cdLoad, _cdSave, _cdSeed, _cdRandom, _cdWrap
PalWndNotify	dd _ReturnFalse, _ReturnFalse, _ReturnFalse, _ReturnFalse
		dd _pdSet2, _ReturnFalse, _ReturnFalse, _pdSet3, _ReturnFalse
		dd _pdInsert, _pdDelete, _ReturnFalse, _pdAlign

Colors		dd szRed, szGreen, szBlue

BitmapFileHdr	BITMAPFILEHEADER <'MB', (size BITMAPFILEHEADER +\
				  size BITMAPINFOHEADER + 256*4 + 256*256)\
				  shr 2, 0, size BITMAPFILEHEADER +\
				  size BITMAPINFOHEADER + 256*4>

BitmapInfoHdrR	BITMAPINFOHEADER <size BITMAPINFOHEADER, 256, 1, 1, 8, 0, 256,\
				  0, 0, 0, 0>

OpenFileStruc	OPENFILENAME <size OPENFILENAME, 0, 0, 0, 0, 0, 1, O szFile,\
			      MAXFILENAMELEN, 0, 0, 0, 0, 0, 0, 0, O szDefExt,\
			      0, 0, 0>
szSaveFilters	db 'Bitmaps (*.bmp)', 0, '*.bmp', 0
szOpenFilters	db 'Clouds (*.cld)', 0
szDefExt	db '*.cld', 0, 0
hwndMain	= OpenFileStruc.hwndOwner

codeseg

proc	WinMain hInst, hPrecInstance, lpszCmdLine, nCmdShow
	mov	esi, O BitmapInfoHdrR		; Initialize data
	mov	edi, O BitmapInfoHdr
	mov	ecx, (size BITMAPINFOHEADER) shr 2
	cld
	rep	movsd
	mov	[byte szFile], 0
	mov	[dword RedPoints], 0FFFF0000h
	mov	[dword GreenPoints], 0FFFF0000h
	mov	[dword BluePoints], 0FFFFFF00h
	sub	esp, size SYSTEMTIME		; Initialize random seeds
	mov	eax, esp
	call	GetSystemTime, eax
	xor	eax, eax
	mov	ecx, (size SYSTEMTIME) shr 2
_cdRandomSeed:
	pop	edx
	add	eax, edx
	loop	_cdRandomSeed
	or	al, 1
	imul	eax, RANDOMBASE
	mov	[GlobalSeed], eax
	mov	[Seed], eax
	mov	edi, O PalBitmap		; Setup palette sample
	mov	eax, 03020100h
	mov	ecx, 64
	cld
_rpSetupBitmap:
	stosd
	add	eax, 04040404h
	loop	_rpSetupBitmap

	call	GetModuleHandle, 0		; Register window classes
	mov	[hInstance], eax
	mov	[CloudClass.hInstance], eax
	mov	[ChartClass.hInstance], eax
	mov	[PaletteClass.hInstance], eax
	mov	[OpenFileStruc.hInstance], eax
	mov	ebx, eax
	call	LoadIcon, eax, ID_ICON
	mov	[MainClass.hIcon], eax
	call	LoadCursor, 0, IDC_ARROW
	mov	[MainClass.hCursor], eax
	mov	[CloudClass.hCursor], eax
	mov	[ChartClass.hCursor], eax
	mov	[PaletteClass.hCursor], eax
	call	RegisterClass, O MainClass
	call	RegisterClass, O CloudClass
	call	RegisterClass, O ChartClass
	call	RegisterClass, O PaletteClass
						; Create main window
	call	CreateWindowEx, 0, O szAppName, O szAppName, WS_CAPTION+\
				 WS_BORDER+WS_SYSMENU+WS_MINIMIZEBOX,\
				 CW_USEDEFAULT, 0, 0, 0, 0, 0, ebx, 0
	mov	[hwndMain], eax 		 ; 505, 450
	mov	ebx, eax
	call	ResetPalette
	call	InitConfig
	call	ShowWindow, ebx, SW_NORMAL
	call	UpdateWindow, ebx

	mov	esi, O Message			; Message loop
lb_01:	call	GetMessage, esi, 0, 0, 0
	or	eax, eax
	jz	lb_02
	call	TranslateMessage, esi
	call	DispatchMessage, esi
	jmp	lb_01

lb_02:	call	ExitProcess, [Message.wParam]	; Quit
	; Using ExitProcess() to ensure that all libraries are unloaded
endp

proc	MainWndProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
local Rect: RECT
	mov	eax, [uMsg]			; Dispatch a message
	cmp	eax, WM_CREATE
	jz	_mwCreate
	cmp	eax, WM_DESTROY
	jz	_mwDestroy
	cmp	eax, WM_NOTIFY
	jz	_mwNotify
_mwDefault:
	call	DefWindowProc, [hwnd], eax, [wParam], [lParam]
	ret

_mwCreate:
	call	CreateDialogParam, [hInstance], ID_CLOUDTAB, [hwnd],\
				   O CloudProc, 0
	mov	[hwndCloud], eax
	call	ShowWindow, eax, SW_NORMAL

	call	CreateDialogParam, [hInstance], ID_PALETTETAB, [hwnd],\
				   O PaletteProc, 0
	mov	[hwndPalette], eax

	call	CreateDialogParam, [hInstance], ID_ABOUTTAB, [hwnd], 0, 0
	mov	[hwndAbout], eax

	lea	esi, [Rect]			; Get dialogs sizes
	call	GetWindowRect, eax, esi

	call	InitCommonControls		; Create TabControl
	call	CreateWindowEx, 0, O szTabControl, 0, WS_CHILD+WS_VISIBLE\
				+WS_CLIPCHILDREN, 8, 8, 0, 0, [hwnd],\
				ID_TABCONTROL, [hInstance], 0
	mov	[hwndTabControl], eax
	mov	ebx, eax
						; Update font
	call	GetStockObject, DEFAULT_GUI_FONT
	call	SendMessage, ebx, WM_SETFONT, eax, 0

	sub	esp, size TC_ITEM		; Update tabs
	mov	[(TC_ITEM esp).mask], TCIF_TEXT
	mov	[(TC_ITEM esp).pszText], O szCloud
	mov	[(TC_ITEM esp).cchTextMax], 0
	call	SendMessage, ebx, TCM_INSERTITEM, 0, esp
	mov	[(TC_ITEM esp).pszText], O szPalette
	call	SendMessage, ebx, TCM_INSERTITEM, 1, esp
	mov	[(TC_ITEM esp).pszText], O szAbout
	call	SendMessage, ebx, TCM_INSERTITEM, 2, esp
	add	esp, size TC_ITEM
						; Update tabcontrol's size
	call	SendMessage, ebx, TCM_ADJUSTRECT, 1, esi
	mov	eax, [Rect.right]
	sub	eax, [Rect.left]
	mov	ecx, [Rect.bottom]
	sub	ecx, [Rect.top]
	push	ecx
	push	eax
	call	MoveWindow, ebx, 8, 8, eax, ecx, 0

	mov	ebx, [hwnd]			; Update main window's size
	call	GetWindowRect, ebx, esi
	call	GetSystemMetrics, SM_CXBORDER
	pop	edx
	pop	ecx
	lea	eax, [eax*2+edx+20]
	add	ecx, 16
	add	ecx, [Rect.bottom]
	sub	ecx, [Rect.top]
	call	MoveWindow, ebx, [Rect.left], [Rect.top], eax, ecx, 0
	jmp	_mwOk

_mwDestroy:
	call	PostQuitMessage, 0
	jmp	_mwOk

_mwNotify:
	mov	ebx, [lParam]
	cmp	[(NMHDR ebx).code], TCN_SELCHANGE
	jnz	_mwDefault
	movzx	eax, [Flags]
	and	al, 03h
	mov	eax, [TabWindows+eax*4]
	call	ShowWindow, eax, SW_HIDE
	call	SendMessage, [hwndTabControl], TCM_GETCURSEL, 0, 0
	and	[Flags], 0FCh
	or	[Flags], al
	mov	eax, [TabWindows+eax*4]
	call	ShowWindow, eax, SW_SHOW

_ReturnFalse:
_mwOk:	xor	eax, eax
	ret
endp

proc	CloudProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ebx, [hwnd]
	mov	eax, [uMsg]
	cmp	eax, WM_COMMAND
	jz	_cdCommand
	cmp	eax, WM_HSCROLL
	jz	_cdHScroll
	cmp	eax, WM_INITDIALOG
	jz	_cdInitDialog
	jmp	_ReturnFalse

_cdInitDialog:
						; Initialize density trackbar
	call	SendDlgItemMessage, ebx, ID_DENSITYTRACK, TBM_SETPOS, 1, 50
	call	SendDlgItemMessage, ebx, ID_DENSITYTRACK, TBM_SETRANGE,\
				    0, (100 shl 16)+1
	call	SendDlgItemMessage, ebx, ID_DENSITYTRACK, TBM_SETTICFREQ, 10, 0

_ReturnTrue:
	mov	eax, 1
	ret

_cdCommand:
	movzx	eax, [word wParam]
	sub	eax, 101
	jc	_ReturnFalse
	cmp	eax, 5
	ja	_ReturnFalse
	movzx	ecx, [word wParam+2]
	mov	eax, [CloudWndNotify+eax*4]
	jmp	eax
_cdRandom:					; Random Button
	mov	eax, [GlobalSeed]
	imul	eax, RANDOMBASE
	mov	[GlobalSeed], eax
	mov	[Seed], eax
	call	SetDlgItemInt, ebx, ID_SEED, eax, 0
	jmp	_cdExec
_cdSeed:					; Seed Edit
	cmp	ecx, EN_UPDATE
	jnz	_ReturnFalse
	push	eax
	mov	eax, esp
	call	GetDlgItemInt, ebx, ID_SEED, eax, 0
	pop	ecx
	or	ecx, ecx
	jz	_cdResetSeed
	or	eax, eax
	jnz	_cdSeedOk
_cdResetSeed:
	call	SetDlgItemInt, ebx, ID_SEED, [Seed], 0
	mov	eax, [Seed]
_cdSeedOk:
	mov	[Seed], eax
	jmp	_cdExec
_cdWrap:					; Wrap CheckBox
	call	IsDlgButtonChecked, ebx, ID_WRAP
	and	[Flags], not flagWrap
	mov	[Fractal], O FracNonWrap
	or	eax, eax
	jz	_cdExec
	mov	[Fractal], O FracWrap
	or	[Flags], flagWrap
	jmp	_cdExec
_cdHScroll:					; Density TrackBar
	call	SendMessage, [lParam], TBM_GETPOS, 0, 0
	mov	[Density], eax
	call	SetDlgItemInt, ebx, ID_DENSITY, eax, 0
_cdExec:
	or	[Flags], flagToCreate
	call	GetDlgItem, ebx, ID_CLOUD
	call	RedrawWindow, eax, 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	jmp	_ReturnTrue
_cdLoad:					; Load Button
	mov	[OpenFileStruc.Flags], OFN_HIDEREADONLY+OFN_FILEMUSTEXIST+\
					 OFN_PATHMUSTEXIST
	mov	[OpenFileStruc.lpstrFilter], O szOpenFilters
	call	GetOpenFileName, O OpenFileStruc
	or	eax, eax
	jz	_ReturnTrue
	call	CreateFile, O szFile, GENERIC_READ, FILE_SHARE_READ, 0,\
			    OPEN_EXISTING, 0, 0
	cmp	eax, -1
	jz	_cdOpenError
	mov	ebx, eax
	push	eax
	mov	eax, esp
	call	ReadFile, ebx, O LoadArea, size LOADAREASTR, eax, 0
	or	eax, eax
	pop	eax
	jz	_cdOpenError2
	call	CloseHandle, ebx
	cmp	[LoadArea.Signature], SIGNATURE
	jnz	_cdOpenError
	mov	al, [LoadArea.NumRedPoints]
	cmp	al, 2
	jc	_cdOpenError
	cmp	al, MAXPOINTS
	ja	_cdOpenError
	mov	ah, al
	mov	al, [LoadArea.NumGreenPoints]
	add	ah, al
	cmp	al, 2
	jc	_cdOpenError
	cmp	al, MAXPOINTS
	ja	_cdOpenError
	mov	al, [LoadArea.NumBluePoints]
	add	ah, al
	cmp	al, 2
	jc	_cdOpenError
	cmp	al, MAXPOINTS
	ja	_cdOpenError
	movzx	eax, ah
	add	eax, 13
	cmp	eax, esi
	ja	_cdOpenError
	mov	al, [LoadArea.NumRedPoints]
	mov	[NumRedPoints], al
	mov	al, [LoadArea.NumGreenPoints]
	mov	[NumGreenPoints], al
	mov	al, [LoadArea.NumBluePoints]
	mov	[NumBluePoints], al
	movzx	eax, [Chart1Is]
	mov	al, [NumRedPoints+eax]
	mov	[NumPoints], eax
	mov	[PointSelected], 0
	mov	eax, [LoadArea.Seed]
	mov	[Seed], eax
	movzx	eax, [LoadArea.Density]
	cmp	al, 100
	jna	_cdDensityFix1
	mov	al, 100
_cdDensityFix1:
	cmp	al, 0
	jnz	_cdDensityFix2
	mov	al, 1
_cdDensityFix2:
	mov	[Density], eax
	and	[Flags], not flagWrap
	mov	[Fractal], O FracNonWrap
	cmp	[LoadArea.Tile], 0
	jz	_cdWrapFix
	mov	[Fractal], O FracWrap
	or	[Flags], flagWrap
_cdWrapFix:
	mov	esi, O LoadArea.Points
	mov	edi, O RedPoints
	movzx	ecx, [NumRedPoints]
	shl	ecx, 1
	cld
	rep	movsb
	mov	edi, O GreenPoints
	movzx	ecx, [NumGreenPoints]
	shl	ecx, 1
	rep	movsb
	mov	edi, O BluePoints
	movzx	ecx, [NumBluePoints]
	shl	ecx, 1
	rep	movsb
	or	[Flags], flagToCreate
	call	ResetPalette
	call	InitConfig
	jmp	_ReturnTrue
_cdSave:
	cmp	[byte szFile], 0
	jz	_cdDoSave
	movzx	eax, [OpenFileStruc.nFileExtension]
	sub	eax, 1
	jna	_cdDoSave
	mov	[byte szFile+eax], 0
_cdDoSave:
	mov	[OpenFileStruc.Flags], OFN_HIDEREADONLY+OFN_OVERWRITEPROMPT
	mov	[OpenFileStruc.lpstrFilter], O szSaveFilters
	call	GetSaveFileName, O OpenFileStruc
	or	eax, eax
	jz	_ReturnTrue
	call	CreateFile, O szFile, GENERIC_WRITE, FILE_SHARE_READ, 0,\
			    CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0
	cmp	eax, -1
	jz	_cdSaveError
	mov	ebx, eax
	movzx	eax, [OpenFileStruc.nFileExtension]
	add	eax, O szFile
	cmp	[byte eax], 'b'
	jz	_cdSaveBitmap
	cmp	[byte eax], 'B'
	jz	_cdSaveBitmap
	mov	[LoadArea.Signature], SIGNATURE
	mov	eax, [Seed]
	mov	[LoadArea.Seed], eax
	mov	al, [byte Density]
	mov	[LoadArea.Density], al
	test	[Flags], flagWrap
	setnz	[LoadArea.Tile]
	mov	al, [NumRedPoints]
	mov	[LoadArea.NumRedPoints], al
	mov	al, [NumGreenPoints]
	mov	[LoadArea.NumGreenPoints], al
	mov	al, [NumBluePoints]
	mov	[LoadArea.NumBluePoints], al
	mov	esi, O RedPoints
	mov	edi, O LoadArea.Points
	movzx	ecx, [NumRedPoints]
	shl	ecx, 1
	cld
	rep	movsb
	mov	esi, O GreenPoints
	movzx	ecx, [NumGreenPoints]
	shl	ecx, 1
	rep	movsb
	mov	esi, O BluePoints
	movzx	ecx, [NumBluePoints]
	shl	ecx, 1
	rep	movsb
	mov	eax, O LoadArea
	sub	edi, eax
	push	ecx
	mov	ecx, esp
	call	WriteFile, ebx, eax, edi, ecx, 0
	pop	ecx
	push	eax
	call	CloseHandle, ebx
	pop	eax
	or	eax, eax
	jz	_cdSaveError
	jmp	_ReturnTrue
_cdSaveBitmap:
	push	eax
	mov	eax, esp
	call	WriteFile, ebx, O BitmapFileHdr, size BITMAPFILEHEADER, eax, 0
	pop	ecx
	or	eax, eax
	jz	_cdSaveError2
	mov	[BitmapInfoHdr.biSizeImage], 256*256
	mov	[BitmapInfoHdr.biHeight], 256
	push	eax
	mov	eax, esp
	call	WriteFile, ebx, O BitmapInfoHdr, size BITMAPINFOHEADER+256*4,\
			   eax, 0
	pop	ecx
	mov	[BitmapInfoHdr.biSizeImage], 256
	mov	[BitmapInfoHdr.biHeight], 1
	mov	esi, O CloudBmp + 255*257
	mov	edi, 256
_cdSaveScanline:
	push	eax
	mov	eax, esp
	call	WriteFile, ebx, esi, 256, eax, 0
	pop	ecx
	sub	esi, 257
	dec	edi
	jnz	_cdSaveScanline
	call	CloseHandle, ebx
	jmp	_ReturnTrue
_cdSaveError2:
	call	CloseHandle, ebx
_cdSaveError:
	mov	esi, O szSaveError
	jmp	_cdOpenError_
_cdOpenError2:
	call	CloseHandle, ebx
_cdOpenError:
	mov	esi, O szOpenError
_cdOpenError_:
	call	MessageBox, [hwndMain], esi, O szError, MB_ICONEXCLAMATION
	jmp	_ReturnTrue
endp

proc	PaletteProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ebx, [hwnd]
	mov	eax, [uMsg]
	cmp	eax, WM_COMMAND
	jz	_pdCommand
	cmp	eax, WM_INITDIALOG
	jz	_ReturnTrue
	jmp	_ReturnFalse

_pdCommand:
	movzx	eax, [word wParam]
	sub	eax, 101
	jc	_ReturnFalse
	cmp	eax, 12
	ja	_ReturnFalse
	movzx	ecx, [word wParam+2]
	mov	eax, [PalWndNotify+eax*4]
	jmp	eax

_pdSet2:					; Set Button
	movzx	eax, [Chart2Is]
	xchg	al, [Chart1Is]
	mov	[Chart2Is], al
	mov	eax, [Colors+eax*4]
	call	SetDlgItemText, ebx, ID_COLOR2, eax
	jmp	_pdSet
_pdSet3:					; Set Button
	movzx	eax, [Chart3Is]
	xchg	al, [Chart1Is]
	mov	[Chart3Is], al
	mov	eax, [Colors+eax*4]
	call	SetDlgItemText, ebx, ID_COLOR3, eax
_pdSet: movzx	eax, [Chart1Is]
	movzx	ecx, [byte NumRedPoints+eax]
	mov	[NumPoints], ecx
	cmp	[PointSelected], cl
	jc	_pdSetOk
	dec	cl
	mov	[PointSelected], cl
_pdSetOk:
	mov	ecx, eax
	imul	ecx, 2*MAXPOINTS
	add	ecx, O RedPoints
	mov	[PointsAddr], ecx
	call	SetDlgItemText, ebx, ID_COLOR1, [Colors+eax*4]
	call	GetDlgItem, ebx, ID_COLOR1CHART
	call	RedrawWindow, eax, 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	jmp	_ReturnTrue
_pdInsert:					; Insert Button
	movzx	eax, [byte NumPoints]
	cmp	al, MAXPOINTS
	jnc	_ReturnFalse
	dec	al
	cmp	[PointSelected], al
	mov	al, [PointSelected]
	jc	_pdAddPoint
	dec	al
_pdAddPoint:
	movzx	ecx, [Chart1Is]
	inc	[byte NumRedPoints+ecx]
	inc	[NumPoints]
	mov	ecx, [NumPoints]
	mov	esi, [PointsAddr]
	lea	esi, [esi+ecx*2-2]
	lea	edi, [esi+2]
	mov	ecx, [NumPoints]
	sub	ecx, eax
	lea	ecx, [ecx*2-2]
	std
	rep	movsb
	cld
	mov	esi, [PointsAddr]
	lea	esi, [esi+eax*2]
	inc	al
	mov	[PointSelected], al
	movzx	eax, [byte esi]
	movzx	ecx, [byte esi+1]
	movzx	edx, [byte esi+4]
	add	eax, edx
	shr	eax, 1
	mov	[esi+2], al
	movzx	eax, [byte esi+5]
	add	eax, ecx
	shr	eax, 1
	mov	[esi+3], al
	call	GetDlgItem, ebx, ID_COLOR1CHART
	call	RedrawWindow, eax, 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	jmp	_ReturnTrue

_pdDelete:					; Delete Button
	cmp	[NumPoints], 2
	jz	_ReturnFalse
	dec	[NumPoints]
	movzx	eax, [Chart1Is]
	dec	[byte NumRedPoints+eax]
	mov	al, [PointSelected]
	or	al, al
	jnz	_pdChkLast
	inc	al
_pdChkLast:
	cmp	al, [byte NumPoints]
	jc	_pdRemovePt
	dec	al
_pdRemovePt:
	mov	edi, [PointsAddr]
	lea	edi, [edi+eax*2]
	lea	esi, [edi+2]
	mov	ecx, [NumPoints]
	sub	ecx, eax
	shl	ecx, 1
	cld
	rep	movsb
	sub	[PointSelected], 1
	jnc	_pdRedraw
	mov	[PointSelected], 0
	jmp	_pdRedraw
_pdAlign:
	mov	ecx, [NumPoints]
	mov	eax, 0
	call	FixNumPoints
	inc	eax
	call	FixNumPoints
	inc	eax
	call	FixNumPoints
	mov	eax, O RedPoints
	lea	esi, [eax+2*MAXPOINTS]
	lea	edx, [esi+2*MAXPOINTS]
	dec	cl
	cmp	[PointSelected], cl
	jna	_pdAlignNoSelChange
	mov	[PointSelected], cl
_pdAlignNoSelChange:
	cmp	[Chart1Is], 1
	jc	_pdAlignLoop
	xchg	eax, esi
	jz	_pdAlignLoop
	xchg	eax, edx
_pdAlignLoop:
	mov	ch, [eax]
	mov	[esi], ch
	mov	[edx], ch
	add	eax, 2
	add	esi, 2
	add	edx, 2
	dec	cl
	jnz	_pdAlignLoop
	mov	[byte eax], 0FFh
	mov	[byte esi], 0FFh
	mov	[byte edx], 0FFh
_pdRedraw:
	call	ResetPalette
	call	GetDlgItem, ebx, ID_COLOR1CHART
	call	RedrawWindow, eax, 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	jmp	_ReturnTrue
endp

proc	FixNumPoints uses eax ecx
	movzx	edx, [byte NumRedPoints+eax]
	mov	[NumRedPoints+eax], cl
	cmp	dl, cl
	jnc	_fnpEnd
	imul	eax, 2*MAXPOINTS
	lea	edi, [RedPoints+eax+edx*2]
	sub	cl, dl
	mov	al, 0FFh
	mov	ah, [edi-1]
	cld
	rep	stosw
_fnpEnd:
	ret
endp

proc	InitConfig uses ebx esi
	mov	esi, [hwndCloud]		; Cloud config
	call	SetDlgItemInt, esi, ID_SEED, [Seed], 0
	call	SetDlgItemInt, esi, ID_DENSITY, [Density], 0
	call	SendDlgItemMessage, esi, ID_DENSITYTRACK, TBM_SETPOS,\
				     1, [Density]
	xor	ebx, ebx
	test	[Flags], flagWrap
	setnz	bl
	call	CheckDlgButton, esi, ID_WRAP, ebx

	mov	al, [Flags]			; Redraw current dialog
	and	al, 03h
	cmp	al, 1
	ja	_icNoRedraw
	jz	_icRedraw
	mov	esi, [hwndCloud]
_icRedraw:
	call	RedrawWindow, esi, 0, 0, RDW_UPDATENOW + RDW_ALLCHILDREN +\
			      RDW_INVALIDATE
_icNoRedraw:
	ret
endp

proc	CloudWndProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
local PS: PAINTSTRUCT
	mov	ebx, [hwnd]
	mov	eax, [uMsg]
	cmp	eax, WM_PAINT
	jz	_cwpPaint
	call	DefWindowProc, ebx, eax, [wParam], [lParam]
	ret
_cwpPaint:
	test	[Flags], flagToCreate
	jz	_cwpOnlyRedraw

	call	[Fractal]
	and	[Flags], not flagToCreate

_cwpOnlyRedraw:
	lea	eax, [PS]
	call	BeginPaint, ebx, eax

	mov	ecx, 256			; Display bitmap
	mov	esi, O CloudBmp
	xor	edi, edi
_dwpDrawNext:
	push	ecx
	call	SetDIBitsToDevice, [PS.hdc], 0, edi, 256, 1, 0, 0, 0, 1,\
				   esi, O BitmapInfoHdr, DIB_RGB_COLORS
	inc	edi
	add	esi, 257
	pop	ecx
	loop	_dwpDrawNext

	lea	eax, [PS]
	call	EndPaint, ebx, eax
	jmp	_ReturnFalse
endp

proc	ChartWndProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
local PS: PAINTSTRUCT
local Rect: RECT
local LogBrush: LOGBRUSH
local BlueBrush, RedBrush
	mov	eax, [uMsg]			; Dispatch messages
	mov	ebx, [hwnd]
	cmp	eax, WM_MOUSEMOVE
	jz	_c1MouseMove
	cmp	eax, WM_PAINT
	jz	_c1Paint
	cmp	eax, WM_LBUTTONDOWN
	jz	_c1LButtonDown
	cmp	eax, WM_LBUTTONUP
	jz	_c1LButtonUp
	call	DefWindowProc, ebx, eax, [wParam], [lParam]
	ret
_c1Paint:					; Handle WM_PAINT
	lea	eax, [PS]
	call	BeginPaint, ebx, eax
	mov	ebx, [PS.hdc]

	mov	[LogBrush.lbStyle], BS_SOLID	; Create brushes
	mov	[dword LogBrush.lbColor], 00FF0000h
	lea	esi, [LogBrush]
	call	CreateBrushIndirect, esi
	mov	[BlueBrush], eax
	mov	[dword LogBrush.lbColor], 000000FFh
	call	CreateBrushIndirect, esi
	mov	[RedBrush], eax

	call	GetStockObject, WHITE_BRUSH
	mov	[Rect.left], 0
	mov	[Rect.top], 0
	mov	[Rect.right], 256
	mov	[Rect.bottom], 256
	lea	ecx, [Rect]
	call	FillRect, ebx, ecx, eax

	mov	ecx, [NumPoints]		; Prepare to draw the chart
	mov	esi, [PointsAddr]

	push	ecx				; First point
	movzx	eax, [byte esi+1]
	sub	eax, 255
	neg	eax
	call	MoveToEx, ebx, 0, eax, 0
	jmp	_pdDrawPoint

_pdNextPoint:
	push	ecx				; Draw line
	movzx	ecx, [byte esi]
	movzx	eax, [byte esi+1]
	sub	eax, 255
	neg	eax
	call	LineTo, ebx, ecx, eax

_pdDrawPoint:
	movzx	eax, [byte esi] 		; Draw point
	sub	eax, 2
	movzx	ecx, [byte esi+1]
	sub	ecx, 253
	neg	ecx
	mov	[Rect.left], eax
	mov	[Rect.top], ecx
	add	eax, 5
	mov	[Rect.right], eax
	add	ecx, 5
	mov	[Rect.bottom], ecx
	lea	ecx, [Rect]
	mov	al, [byte NumPoints]
	sub	al, [PointSelected]
	cmp	[esp], al
	mov	eax, [BlueBrush]
	jnz	_c1NotSelected
	mov	eax, [RedBrush]
_c1NotSelected:
	call	FillRect, ebx, ecx, eax

	pop	ecx				; Next point
	add	esi, 2
	loop	_pdNextPoint

	call	DeleteObject, [BlueBrush]	; Delete brushes
	call	DeleteObject, [RedBrush]

	lea	eax, [PS]			; Stop drawing
	call	EndPaint, [hwnd], eax
	call	_ReturnFalse

_c1LButtonDown: 				; Handle WM_LBUTTONDOWN
	mov	ecx, [NumPoints]
	mov	eax, [PointsAddr]
	movsx	edx, [word lParam]
	movsx	esi, [word lParam+2]
	sub	esi, 255
	neg	esi
	lea	ebx, [esi+POINTTOLERANCE]
	lea	edi, [edx+POINTTOLERANCE]
	sub	esi, POINTTOLERANCE
	sub	edx, POINTTOLERANCE

_c1FindNextPoint:				; Find close point
	push	ecx
	movzx	ecx, [byte eax]
	cmp	ecx, edx
	jl	_c1TryNext
	cmp	ecx, edi
	jg	_c1TryNext
	movzx	ecx, [byte eax+1]
	cmp	ecx, esi
	jl	_c1TryNext
	cmp	ecx, ebx
	jng	_c1Ok
_c1TryNext:
	pop	ecx
	add	eax, 2
	loop	_c1FindNextPoint
	jmp	_ReturnTrue

_c1Ok:	pop	ecx				; Point found
	mov	al, [byte NumPoints]
	sub	al, cl
	mov	[PointSelected], al
	or	[Flags], flagMoving
	call	SetCapture, [hwnd]
	jmp	_c1Redraw

_c1MouseMove:					; Handle WM_MOUSEMOVE
	test	[Flags], flagMoving
	jz	_ReturnTrue

	mov	eax, [PointsAddr]		; Prepare pointer
	movzx	ecx, [PointSelected]
	lea	eax, [eax+ecx*2]

	movsx	ecx, [word lParam]		; Get new point coordinates
	movsx	edx, [word lParam+2]
	sub	edx, 255
	neg	edx

	cmp	edx, 0				; Setup Y position
	jnl	_c1YUp
	xor	edx, edx
	jmp	_c1MvY
_c1YUp: cmp	edx, 255
	jng	_c1MvY
	mov	edx, 255
_c1MvY: mov	[eax+1], dl

	mov	bl, [PointSelected]		; Exclude first and last points
	or	bl, bl
	jz	_c1SetPoints
	inc	bl
	cmp	bl, [byte NumPoints]
	jnc	_c1SetPoints

	movzx	ebx, [byte eax-2]		; Exclude when moving over neigh
	cmp	ebx, ecx
	jnl	_c1SetPoints
	movzx	ebx, [byte eax+2]
	cmp	ebx, ecx
	jng	_c1SetPoints

	mov	[eax], cl			; Setup X position and view
_c1SetPoints:
	call	ResetPalette
_c1Redraw:
	call	RedrawWindow, [hwnd], 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	jmp	_ReturnFalse

_c1LButtonUp:					; Handle WM_LBUTTONUP
	test	[Flags], flagMoving
	jz	_ReturnTrue
	and	[Flags], not flagMoving
	call	ReleaseCapture
	jmp	_ReturnFalse
endp

proc	PaletteWndProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
local PS: PAINTSTRUCT
	mov	ebx, [hwnd]
	mov	eax, [uMsg]
	cmp	eax, WM_PAINT
	jz	_pwpPaint
	call	DefWindowProc, ebx, eax, [wParam], [lParam]
	ret
_pwpPaint:
	lea	edi, [PS]
	call	BeginPaint, ebx, edi

	xor	esi, esi
_pwpNextScanLine:
	call	SetDIBitsToDevice, [PS.hdc], 0, esi, 256, 1, 0, 0, 0, 1,\
				   O PalBitmap, O BitmapInfoHdr, DIB_RGB_COLORS
	inc	esi
	cmp	esi, 29
	jc	_pwpNextScanLine

	call	EndPaint, ebx, edi
	jmp	_ReturnFalse
endp

proc	ResetPalette uses ebx esi edi
	mov	edi, O palEntries + 2		; Prepare to setup palette
	mov	eax, O NumRedPoints
	mov	esi, O RedPoints
	mov	ecx, 3

_rpNextComponent:
	push	ecx				; Save registers
	push	eax
	push	esi
	push	edi
	movzx	ecx, [byte eax]
	dec	ecx

_rpNextLine:					; Prepare to draw line
	push	ecx
	movzx	ecx, [byte esi+2]
	sub	cl, [esi]
	movzx	eax, [byte esi+3]
	movzx	edx, [byte esi+1]
	sub	eax, edx
	setc	bl
	jnc	_rpNoNegDY
	neg	eax
_rpNoNegDY:
	xor	edx, edx
	div	cx
	mov	bh, al
	mov	ah, dl
	mov	al, 0
	div	cl
	or	bl, bl
	mov	bl, 0
	mov	ah, al
	xchg	ah, bh
	mov	al, [byte esi+1]
	jnz	_rpLineDown

_rpLineUp:					; Draw line
	stosb
	add	bl, bh
	adc	al, ah
	add	edi, 3
	loop	_rpLineUp
	jmp	_rpLineEnd
_rpLineDown:
	stosb
	add	bl, bh
	sbb	al, ah
	add	edi, 3
	loop	_rpLineDown

_rpLineEnd:					; Next line
	add	esi, 2
	pop	ecx
	loop	_rpNextLine
	stosb

	pop	edi				; Next componenet
	dec	edi
	pop	esi
	add	esi, 2*MAXPOINTS
	pop	eax
	inc	eax
	pop	ecx
	loop	_rpNextComponent

	mov	eax, [hwndPalette]
	call	GetDlgItem, eax, ID_PALETTE
	call	RedrawWindow, eax, 0, 0, RDW_UPDATENOW + RDW_INVALIDATE
	ret
endp

;	in	ebx - RandSeed
;	out	edx - Random Number
;	destr	eax

macro	Random
local _Zero
	xor	edx, edx
	cmp	[RandDelta], 0
	jz	_Zero
	imul	ebx, RANDOMBASE
	mov	eax, ebx
	div	[RandDelta2]
	sub	edx, [RandDelta]
_Zero:
endm

macro	FixRandom
local _ChkZero, _RandOk
	add	eax, edx
	cmp	eax, 255
	jng	_ChkZero
	mov	al, 255
	jmp	_RandOk
_ChkZero:
	cmp	eax, 0
	jnl	_RandOk
	mov	al, 0
_RandOk:
endm

macro	Frac Wrap
local _fNextIter, _fDiagY, _fDiagDoY, _fDiagX, _fDiagDoX
local _fHorzY, _fHorzFixLine1, _fHorzFixLine4, _fHorzX, _fHorzFixLine3
local _fVertX, _fVertFixLine3, _fVertFixLine2, _fVertY, _fVertFixLine4
	mov	ecx, [Density]			; Prepare random num generator
	imul	ecx, DENSITYSCALE
	mov	[RandDelta], ecx
	mov	[Delta], 128
	mov	[Delta2], 256
	mov	[NumLoops], 1
	mov	ebx, [Seed]

	imul	ebx, RANDOMBASE 		; Init corner points
	mov	[CloudBmp], bh
if (Wrap eq 0)
	imul	ebx, RANDOMBASE
	mov	[CloudBmp+256], bh
	imul	ebx, RANDOMBASE
	mov	[CloudBmp+256*257], bh
	imul	ebx, RANDOMBASE
	mov	[CloudBmp+256*258], bh
endif
	mov	ecx, 8				; Next iteration starts here
_fNextIter:
	push	ecx
	mov	eax, [RandDelta]
	shl	eax, 1
	inc	eax
	mov	[RandDelta2], eax
	mov	eax, [Delta2]
	shl	eax, 8
	add	eax, [Delta2]
	mov	[VertDelta2], eax

	mov	ecx, [NumLoops] 		; Prepare to diagonal average
	mov	edi, O CloudBmp

_fDiagY:					; Diagonal average y-loop
	push	ecx
	mov	esi, edi
	mov	edx, [VertDelta2]
	add	edi, edx
	push	edi
	shr	edx, 1
	lea	eax, [esi+edx]
	add	eax, [Delta]
if (Wrap eq 1)
	cmp	ecx, 1
	jnz	_fDiagDoY
	mov	edi, O CloudBmp
_fDiagDoY:
endif
	movzx	edx, [byte esi]
	add	dl, [edi]
	adc	dh, 0
	mov	ecx, [NumLoops]

_fDiagX:					; Diagonal average x-loop
	push	ecx
	push	eax
	add	esi, [Delta2]
	add	edi, [Delta2]
if (Wrap eq 1)
	cmp	ecx, 1
	jnz	_fDiagDoX
	sub	esi, 256
	sub	edi, 256
_fDiagDoX:
endif
	movzx	ecx, [byte esi]
	add	cl, [edi]
	adc	ch, 0
	push	edx
	Random
	pop	eax
	add	eax, ecx
	shr	eax, 2
	FixRandom
	mov	edx, ecx
	pop	ecx
	mov	[ecx], al
	mov	eax, ecx
	add	eax, [Delta2]

	pop	ecx				; Next diagonal average
	loop	_fDiagX
	pop	edi
	pop	ecx
	dec	ecx
	jnz	_fDiagY

	mov	ecx, [NumLoops] 		; Prepare to horizontal average
if (Wrap eq 0)
	inc	ecx
endif
	mov	edi, O CloudBmp
	add	edi, [Delta]

_fHorzY:					; Horizontal average y-loop
	push	ecx
	push	edi
	mov	eax, [VertDelta2]
	shr	eax, 1
	mov	esi, edi
	sub	esi, eax
	cmp	ecx, [NumLoops]
if (Wrap eq 1)
	jc	_fHorzFixLine1
	add	esi, 256*257
else
	jna	_fHorzFixLine1
	add	esi, [VertDelta2]
endif
_fHorzFixLine1:
	add	eax, edi
if (Wrap eq 0)
	cmp	ecx, 1
	jnz	_fHorzFixLine4
	sub	eax, [VertDelta2]
_fHorzFixLine4:
endif
	mov	ecx, [NumLoops]

_fHorzX:					; Horizontal average x-loop
	movzx	edx, [byte eax]
	push	eax
	mov	eax, edi
	sub	eax, [Delta]
	add	dl, [eax]
	adc	dh, 0
	add	eax, [Delta2]
if (Wrap eq 1)
	cmp	ecx, 1
	jnz	_fHorzFixLine3
	sub	eax, 256
_fHorzFixLine3:
endif
	add	dl, [eax]
	adc	dh, 0
	add	dl, [esi]
	adc	dh, 0
	shr	edx, 2
	push	edx
	Random
	pop	eax
	FixRandom
	mov	[edi], al
	pop	eax

	add	eax, [Delta2]			; Next horizontal average
	add	esi, [Delta2]
	add	edi, [Delta2]
	loop	_fHorzX
	pop	edi
	add	edi, [VertDelta2]
	pop	ecx
	dec	ecx
	jnz	_fHorzY

	mov	ecx, [NumLoops] 		; Prepare to vertical average
if (Wrap eq 0)
	inc	ecx
endif
	mov	edi, [VertDelta2]
	shr	edi, 1
	add	edi, O CloudBmp

_fVertX:					; Vertical average x-loop
	push	ecx
	push	edi
	mov	esi, edi
	add	esi, [Delta]
if (Wrap eq 0)
	cmp	ecx, 1
	jnz	_fVertFixLine3
	sub	esi, [Delta2]
_fVertFixLine3:
endif
	mov	eax, edi
	sub	eax, [Delta]
	cmp	ecx, [NumLoops]
if (Wrap eq 1)
	jnz	_fVertFixLine2
	add	eax, 256
else
	jna	_fVertFixLine2
	add	eax, [Delta2]
endif
_fVertFixLine2:
	mov	ecx, [NumLoops]

_fVertY:					; Vertical average y-loop
	movzx	edx, [byte eax]
	push	eax
	mov	eax, [VertDelta2]
	shr	eax, 1
	neg	eax
	add	eax, edi
	add	dl, [eax]
	adc	dh, 0
	add	eax, [VertDelta2]
if (Wrap eq 1)
	cmp	ecx, 1
	jnz	_fVertFixLine4
	sub	eax, 256*257
_fVertFixLine4:
endif
	add	dl, [eax]
	adc	dh, 0
	add	dl, [esi]
	adc	dh, 0
	shr	edx, 2
	push	edx
	Random
	pop	eax
	FixRandom
	mov	[edi], al
	pop	eax

	add	eax, [VertDelta2]		; Next vertical average
	add	esi, [VertDelta2]
	add	edi, [VertDelta2]
	loop	_fVertY
	pop	edi
	add	edi, [Delta2]
	pop	ecx
	dec	ecx
	jnz	_fVertX

	shr	[RandDelta], 1			; Next iteration
	shr	[Delta], 1
	shr	[Delta2], 1
	shl	[NumLoops], 1
	pop	ecx
	dec	ecx
	jnz	_fNextIter

	ret
endm

proc	FracNonWrap
local RandDelta2, RandDelta, Delta, Delta2, VertDelta2, NumLoops
	Frac 0
endp

proc	FracWrap
local RandDelta2, RandDelta, Delta, Delta2, VertDelta2, NumLoops
	Frac 1
endp

end WinMain