udataseg

_X		dt ?				; Compiler variables
_Y		dt ?
_Z		dt ?
P		dt ?
Q		dt ?
T		dt ?
_XMid		dt ?
_YMid		dt ?
_ZMid		dt ?
_XYZScale	dt ?
_PGran		dt ?
_QGran		dt ?
_TMax		dt ?
label Vars
XMid		dd ?
YMid		dd ?
ZMid		dd ?
XYZScale	dd ?
PGran		dd ?
QGran		dd ?
TMax		dd ?
PMin		dt ?
PMax		dt ?
QMin		dt ?
QMax		dt ?
hmemUserBuf	dd ?
PStep		dt ?
QStep		dt ?

dataseg

ErrorType1	db 'Compilation error', 0
ErrorType2	db 'Execution error', 0

codeseg

proc	SetupDefVars
	mov	esi, O DefVars
	mov	edi, O Vars
	call	MoveVars
	ret
endp

proc	SetupBuffers uses ebx esi
	mov	ebx, [PGran]
	imul	ebx, [QGran]
	lea	ebx, [ebx+ebx*2]
	shl	ebx, 2
	mov	esi, O hmem3DPoints
	call	MemAlloc
	mov	esi, O hmem2DPoints
	call	MemAlloc
	ret
endp

proc	Compilation
	call	SetupDefVars			; Setup default variables
	fldz
	fstp	[T]
	push	-7
	fild	[dword esp]
	add	esp, 4
	mov	esi, O XMid
	mov	edi, O _XMid
	mov	ecx, 4
clc_1:	fild	[dword esi]
	add	esi, 4
	fscale
	fstp	[tbyte edi]
	add	edi, 10
	loop	clc_1
	mov	ecx, 3
clc11:	fild	[dword esi]
	fstp	[tbyte edi]
	add	esi, 4
	add	edi, 10
	loop	clc11

	mov	ebx, [OpersSize]		; Allocate memory
	add	ebx, [FnBufferSize]
	add	ebx, [BreakTableSize]
	mov	esi, O hmemCompile
	call	MemAlloc
	xor	eax, eax
	xchg	eax, [hmemExecute]
	or	eax, eax
	jz	clc_4
	call	GlobalFree, eax
clc_4:	mov	eax, [ExecBufferSize]
	add	eax, [NumTableSize]
	add	eax, [ExecStackSize]
	call	GlobalAlloc, GMEM_FIXED, eax
	mov	[hmemExecute], eax
	call	SendMessage, [hwndFormula], WM_GETTEXTLENGTH, 0, 0
	inc	eax
	mov	[UserBufferSize], eax
	mov	ebx, eax
	mov	esi, O hmemUserBuf
	call	MemAlloc

	call	GlobalLock, [hmemCompile]	; Lock memory
	mov	[Opers], eax
	add	eax, [OpersSize]
	mov	[FnBuffer], eax
	add	eax, [FnBufferSize]
	mov	[BreakTable], eax
	mov	eax, [hmemExecute]
	mov	[ExecBuffer], eax
	add	eax, [ExecBufferSize]
	mov	[NumTable], eax
	add	eax, [NumTableSize]
	mov	[ExecStack], eax
	call	GlobalLock, [hmemUserBuf]
	mov	[UserBuffer], eax
	call	SendMessage, [hwndFormula], WM_GETTEXT, ebx, eax

	call	Compile 			; Execute . . .
	pushfd
	sub	esi, [UserBuffer]
	call	FreeMemory
	popfd
	jc	comp_err
	call	XlatValues
	call	SetupBuffers
	mov	[CalcChart], O Calculate
	call	[CalcChart]
	jc	comp_err
	call	UpdateChart
	call	SelectTab, 0
	ret

comp_err:
	mov	edi, O ErrorType2
	cmp	dl, ERR_NEGATIVEVAL
	jnc	ce_01
	push	edx
	mov	ebx, [hwndFormula]
	call	SendMessage, ebx, EM_LINEFROMCHAR, esi, 0
	mov	edi, eax
	call	SendMessage, ebx, EM_LINEINDEX, eax, 0
	call	SendMessage, ebx, EM_SETSEL, eax, esi
	call	SendMessage, ebx, EM_GETFIRSTVISIBLELINE, 0, 0
	sub	edi, eax
	call	SendMessage, ebx, EM_LINESCROLL, 0, edi
	call	SendMessage, ebx, EM_SCROLLCARET, 0, 0
	pop	edx
	mov	edi, O ErrorType1
ce_01:	movzx	ebx, dl
	push	ebx
	push	edi
	call	SelectTab, 1
	pop	edi
	pop	ebx
	call	MessageBox, [hwnd], [Errors+ebx*4], edi, MB_ICONERROR
	ret
endp

proc	FreeMemory uses ebx edx
	mov	ebx, O hmemCompile
	call	GlobalUnlock, [dword ebx]
	mov	eax, ebx
	call	FreeMem
	mov	ebx, O hmemUserBuf
	call	GlobalUnlock, [dword ebx]
	mov	eax, ebx
	call	FreeMem
	ret
endp

align
proc	Calculate
	mov	edi, O _X
	xor	eax, eax
	cld
	mov	ecx, 12
	rep	stosd
	stosb
	stosb

	call	InitCopro

	call	Execute, 1
	jc	clc_err

	dec	[PGran]
	fild	[PGran]
	inc	[PGran]
	fld	[PMax]
	fld	[PMin]
	fsubp	st(1), st
	fdivrp	st(1), st
	fstp	[PStep]

	dec	[QGran]
	fild	[QGran]
	inc	[QGran]
	fld	[QMax]
	fld	[QMin]
	fsubp	st(1), st
	fdivrp	st(1), st
	fstp	[QStep]

	call	GlobalLock, [hmem3DPoints]

	push	7
	fild	[dword esp]
	add	esp, 4
	fld	[QMin]
	mov	ebx, [QGran]
clc_2:	fld	[PMin]
	mov	ecx, [PGran]
clc_3:	fld	st
	fstp	[P]
	fld	st
	fstp	[_X]
	fld	st(1)
	fstp	[Q]
	fld	st(1)
	fstp	[_Y]
	fldz
	fstp	[_Z]
	call	Execute, 0
	jc	clc_err
	fxch	st(2)
	fld	[_X]
	fld	[_XMid]
	fsubp	st(1), st
	fscale
	fistp	[dword eax]
	add	eax, 4
	fld	[_Y]
	fld	[_YMid]
	fsubp	st(1), st
	fscale
	fistp	[dword eax]
	add	eax, 4
	fld	[_Z]
	fld	[_ZMid]
	fsubp	st(1), st
	fscale
	fistp	[dword eax]
	add	eax, 4
	fxch	st(2)
	fld	[PStep]
	faddp	st(1), st
	dec	ecx
	jnz	clc_3
;	 loop	 clc_3
	ffree	st
	fincstp
	fld	[QStep]
	faddp	st(1), st
	dec	ebx
	jnz	clc_2
	fninit
	call	GlobalUnlock, [hmem3DPoints]
	clc
	ret
clc_err:
	fninit
	push	edx
	call	GlobalUnlock, [hmem3DPoints]
	pop	edx
	stc
	ret
endp

proc	InitCopro
	finit
	push	eax
	fstcw	[esp]
	pop	eax
	and	ah, 0F3h
	or	ah, 04h
	push	eax
	fldcw	[esp]
	pop	eax
	ret
endp

proc	XlatGran
	push	eax
	fistp	[dword esp]
	pop	eax
	cmp	eax, 2
	jnl	clc_6
	mov	eax, 2
	jmp	clc_7
clc_6:	cmp	eax, 200
	jng	clc_7
	mov	eax, 200
clc_7:	ret
endp

proc	XlatValues
	call	InitCopro

	push	7
	fild	[dword esp]
	pop	eax
	mov	esi, O _XMid
	mov	edi, O XMid
	mov	ecx, 4
clc_5:	fld	[tbyte esi]
	add	esi, 10
	fscale
	fistp	[dword edi]
	add	edi, 4
	loop	clc_5
	ffree	st

	fld	[_PGran]
	call	XlatGran
	mov	[PGran], eax
	fld	[_QGran]
	call	XlatGran
	mov	[QGran], eax
	fld	[_TMax]
	fistp	[TMax]
	cmp	[TMax], 0
	jnl	clc15
	mov	[TMax], 0
clc15:	ret
endp
