; 28-12-97	final release
; 23-01-98	fixed exp()

O equ <offset>

MAXPRIVLEVEL	= 7*20
FIRSTASSIGNMENT	= OPR_A

; Standard operator/operand types ( * - non-sign types )

OT_UNKNOWN	= 00h		; '$'
OT_NUMBER	= 11h		; '0'
OT_VAR		= 01h		; 'a'
OT_NEWVAR	= 02h	;*	; 'a'
OT_OPERATOR	= 03h		; '+'
OT_SBOPEN	= 04h		; '('
OT_SBCLOSE	= 05h		; ')'
OT_WBOPEN	= 06h		; '{'
OT_WBCLOSE	= 07h		; '}'
OT_END1		= 08h		; ';'
OT_END2		= 09h		; ','
OT_EOF		= 0Ah	;*	; '\0'
OT_RESERVED	= 0Bh	;*	; 'if'
OT_FUN		= 0Ch	;*	; 'sin'
OT_VALUE	= 0Dh	;*	; 'xmin'
OT_CONST	= 0Eh	;*	; 'pi'

; Extended operator/operand types

ET_RESERVED	=  0	; OT_RESERVED
ET_WRITABLE	=  1	; OT_NEWVAR, OT_VALUE
ET_READABLE	=  2	; OT_NUMBER, OT_CONST
ET_RW		=  3	; OT_VAR
ET_EXECUTABLE	=  4	; OT_OPERATOR
ET_OPEN		=  8	; OT_SBOPEN, OT_WBOPEN, OT_FUN
ET_CLOSE	= 16	; OT_SBCLOSE, OT_WBCLOSE, OT_END1, OT_END2, OT_EOF

; Operators

OPR_ADD		=  1	; +
OPR_SUB		=  2	; -
OPR_MUL		=  3	; *
OPR_DIV		=  4	; /
OPR_MOD		=  5	; %
OPR_PWR		=  6	; ^
OPR_SHL		=  7	; <<
OPR_SHR		=  8	; >>
OPR_L		=  9	; <
OPR_G		= 10	; >
OPR_E		= 11	; ==
OPR_LE		= 12	; <=
OPR_GE		= 13	; >=
OPR_NE		= 14	; !=
OPR_AND		= 15	; &&
OPR_OR		= 16	; ||

OPR_NEG		= 17	; -a
OPR_ABS		= 18	; abs()
OPR_SIN		= 19	; sin()
OPR_COS		= 20	; cos()
OPR_ATAN	= 21	; atan()
OPR_LOG		= 22	; log()
OPR_LN		= 23	; ln()
OPR_LG		= 24	; lg()
OPR_SQRT	= 25	; sqrt()
OPR_FRAC	= 26	; frac()
OPR_EXP		= 27	; exp()

OPR_A		= 28	; =
OPR_AADD	= 29	; +=
OPR_ASUB	= 30	; -=
OPR_AMUL	= 31	; *=
OPR_ADIV	= 32	; /=
OPR_AMOD	= 33	; %=
OPR_APWR	= 34	; ^=
OPR_ASHL	= 35	; <<=
OPR_ASHR	= 36	; >>=

; Reserved words

RES_IF		= 0
RES_ELSE	= 1
RES_WHILE	= 2
RES_DO		= 3
RES_FOR		= 4
RES_BREAK	= 5
RES_RETURN	= 6
RES_MAIN	= 7
LASTRESERVED	= RES_MAIN

; Error types

ERR_UNKNOWNSIGN	=  0	; Unknown sign
ERR_UNKNOWNOPER	=  1	; Unknown operator/operand
ERR_INVALIDNUM	=  2	; Invalid number format
ERR_TOOMANYBRCK	=  3	; Too many brackets
ERR_TOOMANYVARS	=  4	; Data buffer overflow
ERR_TMANYBREAKS	=  5	; Too many breaks
ERR_TMANYBLOCKS	=  6	; Too many block instructions
ERR_FNBUFOVER	=  7	; Conversion buffer overflow
ERR_EXECBUFOVER	=  8	; Executable buffer overflow
ERR_OPERANDXP	=  9	; Operand expected
ERR_OPERATORXP	= 10	; Operator expected
ERR_WRITABLEXP	= 11	; Writable variable expected
ERR_EXPRXP	= 12	; Expression expected
ERR_NUMBERXP	= 13	; Number expected
ERR_SBOPENXP	= 14	; '(' expected
ERR_SBCLOSEXP	= 15	; ')' expected
ERR_SEMICXP	= 16	; ';' expected
ERR_OPRAXP	= 17	; '=' expected
ERR_WBCLOSEXP	= 18	; '}' expected
ERR_COMMAXP	= 19	; ',' expected
ERR_WHILEXP	= 20	; 'while' expected
ERR_BREAKOUT	= 21	; Wrong break placement
ERR_MAININ	= 22	; Wrong main placement
ERR_SECONDMAIN	= 23	; Duplicate main label

ERR_NEGATIVEVAL	= 24	; Negative value
ERR_DIVBYZERO	= 25	; Division by zero
ERR_INTEGERXP	= 26	; Non-integer value
ERR_STACKOVER	= 27	; Stack overflow

dataseg

;***********************************************
;		     ! " # $ % & ' ( ) * + , - .  /
SignTypes	db 0,3,0,0,0,3,3,0,4,5,3,3,9,3,17,3
		db 10 dup (17)				; 0..9
;		   : ; < = > ? @
		db 0,8,3,3,3,0,0
		db 26 dup (1)				; A..Z
;		   [ \ ] ^ _ `
		db 0,0,0,3,1,0
		db 26 dup (1)				; a..z
;		   { | } ~
		db 6,3,7,0,0
;***********************************************
ExTypes		db 3,1,4,8,16,8,16,16,16,16,0,8,1,2,-1,-1,2
;***********************************************
;		      + - * / % ^ << >>
OpLevels	db -1,4,4,5,5,5,6,5, 5
;		   < > == <= >= != && ||
		db 3,3,3, 3, 3, 3, 2, 2
		db 11 dup (0)	; functions
;		=,+=,-=,*=,/=,%=,^=,<<=,>>=
		db 9 dup (0)	; previously there were 1s !
;***********************************************
OpAddr		dd O opr_null, O opr_add, O opr_sub, O opr_mul	; '',+,-,*
		dd O opr_div, O opr_mod, O opr_pwr, O opr_shl	; /,%,^,<<
		dd O opr_shr, O opr_l, O opr_g, O opr_e		; >>,<,>,==
		dd O opr_le, O opr_ge, O opr_ne, O opr_and	; <=,>=,!=,&&
		dd O opr_or, O opr_neg, O opr_abs, O opr_sin	; ||,-a,abs,sin
		dd O opr_cos, O opr_atan, O opr_log, O opr_ln
		dd O opr_lg, O opr_sqrt, O opr_frac, O opr_exp
		dd O opr_null, O opr_add, O opr_sub, O opr_mul	; =,+=,-=,*=
		dd O opr_div, O opr_mod, O opr_pwr, O opr_shl, O opr_shr
;***********************************************
StdOpers	db 1, '+', OT_OPERATOR, OPR_ADD, 0, 0, 0
		db 1, '-', OT_OPERATOR, OPR_SUB, 0, 0, 0
		db 1, '*', OT_OPERATOR, OPR_MUL, 0, 0, 0
		db 1, '/', OT_OPERATOR, OPR_DIV, 0, 0, 0
		db 1, '%', OT_OPERATOR, OPR_MOD, 0, 0, 0
		db 1, '^', OT_OPERATOR, OPR_PWR, 0, 0, 0
		db 2, '<<', OT_OPERATOR, OPR_SHL, 0, 0, 0
		db 2, '>>', OT_OPERATOR, OPR_SHR, 0, 0, 0
		db 1, '<', OT_OPERATOR, OPR_L, 0, 0, 0
		db 1, '>', OT_OPERATOR, OPR_G, 0, 0, 0
		db 2, '==', OT_OPERATOR, OPR_E, 0, 0, 0
		db 2, '<=', OT_OPERATOR, OPR_LE, 0, 0, 0
		db 2, '>=', OT_OPERATOR, OPR_GE, 0, 0, 0
		db 2, '!=', OT_OPERATOR, OPR_NE, 0, 0, 0
		db 2, '&&', OT_OPERATOR, OPR_AND, 0, 0, 0
		db 2, '||', OT_OPERATOR, OPR_OR, 0, 0, 0

		db 3, 'abs', OT_FUN, OPR_ABS, 0, 0, 0
		db 3, 'sin', OT_FUN, OPR_SIN, 0, 0, 0
		db 3, 'cos', OT_FUN, OPR_COS, 0, 0, 0
		db 4, 'atan', OT_FUN, OPR_ATAN, 0, 0, 0
		db 3, 'log', OT_FUN, OPR_LOG, 0, 0, 0
		db 2, 'ln', OT_FUN, OPR_LN, 0, 0, 0
		db 2, 'lg', OT_FUN, OPR_LG, 0, 0, 0
		db 4, 'sqrt', OT_FUN, OPR_SQRT, 0, 0, 0
		db 4, 'frac', OT_FUN, OPR_FRAC, 0, 0, 0
		db 3, 'exp', OT_FUN, OPR_EXP, 0, 0, 0

		db 1, '=', OT_OPERATOR, OPR_A, 0, 0, 0
		db 2, '+=', OT_OPERATOR, OPR_AADD, 0, 0, 0
		db 2, '-=', OT_OPERATOR, OPR_ASUB, 0, 0, 0
		db 2, '*=', OT_OPERATOR, OPR_AMUL, 0, 0, 0
		db 2, '/=', OT_OPERATOR, OPR_ADIV, 0, 0, 0
		db 2, '%=', OT_OPERATOR, OPR_AMOD, 0, 0, 0
		db 2, '^=', OT_OPERATOR, OPR_APWR, 0, 0, 0
		db 3, '<<=', OT_OPERATOR, OPR_ASHL, 0, 0, 0
		db 3, '>>=', OT_OPERATOR, OPR_ASHR, 0, 0, 0

		db 2, 'if', OT_RESERVED, RES_IF, 0, 0, 0
		db 4, 'else', OT_RESERVED, RES_ELSE, 0, 0, 0
		db 5, 'while', OT_RESERVED, RES_WHILE, 0, 0, 0
		db 2, 'do', OT_RESERVED, RES_DO, 0, 0, 0
		db 3, 'for', OT_RESERVED, RES_FOR, 0, 0, 0
		db 5, 'break', OT_RESERVED, RES_BREAK, 0, 0, 0
		db 6, 'return', OT_RESERVED, RES_RETURN, 0, 0, 0
		db 4, 'main', OT_RESERVED, RES_MAIN, 0, 0, 0

		db 1, 'x', OT_VAR
		dd O _X
		db 1, 'y', OT_VAR
		dd O _Y
		db 1, 'z', OT_VAR
		dd O _Z
		db 1, 'p', OT_CONST
		dd O P
		db 1, 'q', OT_CONST
		dd O Q
		db 1, 't', OT_CONST
		dd O T
		db 2, 'pi', OT_CONST
		dd O ConstPi
		db 1, 'e', OT_CONST
		dd O ConstE
		db 3, 'l2t', OT_CONST
		dd O ConstL2t
		db 3, 'l2e', OT_CONST
		dd O ConstL2e
		db 3, 'ln2', OT_CONST
		dd O ConstLn2
		db 3, 'lg2', OT_CONST
		dd O ConstLg2
		db 4, 'xmid', OT_VALUE
		dd O _XMid
		db 4, 'ymid', OT_VALUE
		dd O _YMid
		db 4, 'zmid', OT_VALUE
		dd O _ZMid
		db 5, 'scale', OT_VALUE
		dd O _XYZScale
		db 4, 'pmin', OT_VALUE
		dd O PMin
		db 4, 'pmax', OT_VALUE
		dd O PMax
		db 5, 'pgran', OT_VALUE
		dd O _PGran
		db 4, 'qmin', OT_VALUE
		dd O QMin
		db 4, 'qmax', OT_VALUE
		dd O QMax
		db 5, 'qgran', OT_VALUE
		dd O _QGran
		db 4, 'tmax', OT_VALUE
		dd O _TMax
		db 0
label StdOpersEnd
;***********************************************
Error0		db 'Unknown sign', 0
Error1		db 'Unknown operator/operand', 0
Error2		db 'Invalid number format', 0
Error3		db 'Too many brackets', 0
Error4		db 'Data buffer overflow', 0
Error5		db 'Too many breaks', 0
Error6		db 'Too many block instructions', 0
Error7		db 'Conversion buffer overflow', 0
Error8		db 'Executable buffer overflow', 0
Error9		db 'Operand expected', 0
Error10		db 'Operator expected', 0
Error11		db 'Writable variable expected', 0
Error12		db 'Expression expected', 0
Error13		db 'Number expected', 0
Error14		db '''('' expected', 0
Error15		db ''')'' expected', 0
Error16		db ''';'' expected', 0
Error17		db '''='' expected', 0
Error18		db '''}'' expected', 0
Error19		db ''','' expected', 0
Error20		db '''while'' expected', 0
Error21		db 'Wrong break placement', 0
Error22		db 'Wrong main placement', 0
Error23		db 'Duplicate main label', 0
Error24		db 'Negative value', 0
Error25		db 'Division by zero', 0
Error26		db 'Non-integer value', 0
Error27		db 'Stack overflow', 0
Errors		dd O Error0, O Error1, O Error2, O Error3, O Error4, O Error5
		dd O Error6, O Error7, O Error8, O Error9, O Error10, O Error11
		dd O Error12, O Error13, O Error14, O Error15, O Error16
		dd O Error17, O Error18, O Error19, O Error20, O Error21
		dd O Error22, O Error23, O Error24, O Error25, O Error26, O Error27
;***********************************************
ConstPi		dt 4000C90FDAA22168C235h
ConstE		dt 4000ADF85458A2BB4A9Bh
ConstL2t	dt 4000D49A784BCD1B8AFEh
ConstL2e	dt 3FFFB8AA3B295C17F0BCh
ConstLn2	dt 3FFEB17217F7D1CF79ACh
ConstLg2	dt 3FFD9A209A84FBCFF799h
;***********************************************
ResWords	dd O res_if, 0, O res_while, O res_do, O res_for
		dd O res_break, O res_return, O res_main

udataseg

CurrentOper	dw ?
LastOper	dw ?
PrivLevels	db MAXPRIVLEVEL dup (?)
PrivLevelStack	dd ?
CurrentPrivLevel db ?
MainAddr	dd ?
BlockStart	dd ?
BreakTableEnd	dd ?
StackTop	dd ?
UserBufferEnd	dd ?
MaxOpers	dd ?
NumTableEnd	dd ?
MaxNumTable	dd ?
MaxBreakTableEnd dd ?
MaxStackTop	dd ?
MaxFnBuffer	dd ?
MaxExecBuf	dd ?
BooleanFlag	db ?

codeseg

;******************************************************************************
;
;	DecodeOper		Changes user string into internal id
;
;	in	esi - pointer to text
;	out	eax - type specific data
;		dl  - operator/operand type
;		dh  - extended oper type
;		cf  - (bool)error
;
; struc Opers
;	byte  StrLength = C
;	char  Expr[C]
;	byte  Type
;	dword Data
;
;******************************************************************************

proc	DecodeOper uses ebx ecx edi
	mov	ecx, [UserBufferEnd]
	sub	ecx, esi
	jna	cc_02
cc_01:	lodsb					; Skip bytes with no meaning
	cmp	al, ' '
	jg	cc_04
	loop	cc_01

cc_02:	clc					; Return and signalize EOF
	mov	dl, OT_EOF
	jmp	cc_12

cc_03:	mov	edi, esi			; Skip comment
	mov	al, 13
	dec	ecx
	jz	cc_02
	repnz	scasb
	mov	esi, edi
	jz	cc_01
	jmp	cc_02

cc_04:	dec	esi				; Check if comment sign
	cmp	al, '#'
	jz	cc_03

	mov	ebx, O SignTypes		; Prepare to determine type
	mov	edi, esi
	xor	eax, eax

	lodsb					; Determine type
	sub	al, ' '
	mov	dl, [eax+ebx]
	cmp	dl, OT_NUMBER
	jz	cc_041
	cmp	dl, OT_SBOPEN
	jnc	cc_12
cc_041:	mov	dh, 0EFh
	cmp	dl, OT_VAR			; if first is OT_VAR
	jz	cc_06					; then treat OT_NUMBER
	mov	dh, 0FFh				; like OT_VAR
	cmp	dl, OT_UNKNOWN
	jnz	cc_06
	stc
	jmp	cc_12
cc_05:	lodsb
	sub	al, ' '
	jle	cc_07
	mov	al, [eax+ebx]
	and	al, dh
	cmp	dl, al
	jnz	cc_07
cc_06:	loop	cc_05
	inc	esi

cc_07:	mov	ebx, edi			; Calculate length
	dec	esi
	neg	edi
	add	edi, esi			; Save new position
	push	esi
	mov	al, dl
	mov	edx, edi
	cmp	al, OT_NUMBER
	jz	cc_0E

	mov	edi, [Opers]			; Find oper in storage
cc_08:	movzx	ecx, [byte edi]
	inc	edi
	test	cl, cl
	jz	cc_0A
	cmp	cl, dl
	jnz	cc_09
	mov	esi, ebx
	repz	cmpsb
	jz	cc_0C
cc_09:	lea	edi, [edi+ecx+5]		; Skip expression
	jmp	cc_08

cc_0A:	cmp	al, OT_VAR			; If variable - new operand
	jnz	cc_0D
	push	eax
	movzx	eax, dl
	add	eax, [Opers]
	add	eax, 6
	cmp	eax, [MaxOpers]
	pop	eax
	jc	cc_0A1
	mov	dl, ERR_TOOMANYVARS
	stc
	jmp	cc_0B
cc_0A1:	mov	[edi-1], dl			; Add new variable to list
	mov	esi, ebx
	mov	cl, dl
	rep	movsb
	stosb
	mov	dl, OT_NEWVAR
	call	PushNumTable
	jc	cc_0B
	stosd
	mov	[byte edi], 0
cc_0B:	pop	esi
	jmp	cc_12

cc_0C:	mov	dl, [edi]			; Return expr type and data
	mov	eax, [edi+1]
	clc
	jmp	cc_0B

cc_0D:	stc					; Signalize variable
	mov	dl, ERR_UNKNOWNOPER
	jmp	cc_0B

cc_0E:	fldz					; Find comma
	mov	edi, ebx
	mov	ecx, edx
	mov	al, '.'
	repnz	scasb
	jnz	cc_10
	ffree	st
	sub	edx, ecx
	dec	edx

	mov	esi, edi			; If more than one comma exists
	push	ecx				;  return error
	repnz	scasb
	pop	ecx
	jnz	cc_0F
	mov	dl, ERR_INVALIDNUM
	stc
	jmp	cc_0B

cc_0F:	fldl2t					; Decode fraction
	push	ecx
	fild	[dword esp]
	add	esp, 4
	fmulp	st(1), st
	call	f2x
	call	LoadNumber
	jc	cc_11
	fdivrp	st(1), st

cc_10:	mov	esi, ebx			; Decode integer part
	mov	ecx, edx
	call	LoadNumber
	jc	cc_11
	faddp	st(1), st

	call	PushNumTable			; Return number
	jc	cc_0B
	fstp	[tbyte eax]
	mov	dl, OT_NUMBER
	clc
	jmp	cc_0B

cc_11:	ffree	st
	mov	dl, ERR_INVALIDNUM
	jmp	cc_0B

cc_12:	movzx	ebx, dl				; Get extended type
	mov	dh, [ExTypes+ebx-1]
	mov	bx, dx
	xchg	bx, [CurrentOper]
	mov	[LastOper], bx
	ret
endp

;******************************************************************************
;
;	PushNumTable		Allocates more space on NumTable stack
;
;	out	eax - new address
;	destr	ecx
;		edi
;
;******************************************************************************

proc	PushNumTable
	mov	ecx, O NumTableEnd
	mov	eax, [MaxNumTable]
	cmp	[ecx], eax
	jc	cc_121
	mov	dl, ERR_TOOMANYVARS
	stc
	ret
cc_121:	mov	eax, [ecx]
	add	[dword ecx], 10
	mov	ecx, -1
	mov	[eax], ecx
	mov	[eax+4], ecx
	mov	[eax+8], cx
	ret
endp

;******************************************************************************
;
;	LoadNumber		Internal function of DecodeOper
;
;	in	ecx - character count
;		esi - text-number address
;	out	st  - encoded integer number
;		cf  - (bool)error
;	destr	eax
;		edi
;
;******************************************************************************

proc	LoadNumber
	jecxz	cc_13				; Prepare to conv number to BCD
	cmp	ecx, 10
	jna	cc_14
cc_13:	stc
	ret
cc_14:	xor	eax, eax
	push	eax
	push	eax
	push	eax
	mov	edi, esp
	lea	esi, [esi+ecx-1]
	mov	al, -1

cc_15:	mov	ah, al				; Convert number to BCD
	mov	al, [esi]
	dec	esi
	sub	al, '0'
	cmp	ah, -1
	jz	cc_17
	shl	al, 4
	or	al, ah
	stosb
	mov	al, -1
cc_17:	loop	cc_15
	cmp	al, -1
	jz	cc_18
	stosb

cc_18:	fbld	[tbyte esp]			; Load number to st
	add	esp, 12
	clc
	ret
endp

;******************************************************************************
;
;	AddOper		Inserts decoded oper into operation code buffer
;
;	in	dx  - type
;		eax - data
;		edi - fn buffer
;	out	cf  - (bool)error
;
; struc FnBuffer
;	byte  PrivLevel ( 0 - var )
;	byte  ExType ( ET_OPEN - function )
;	dword Data ( data ptr for var, id for operator/fun )
;
;******************************************************************************

proc	AddOper uses ecx
	mov	ecx, O CurrentPrivLevel
	cmp	dh, ET_EXECUTABLE		; Determine type
	jz	cc_1E
	cmp	dh, ET_CLOSE
	jz	cc_1B
	cmp	dh, ET_OPEN
	jnz	cc_1C

	cmp	dl, OT_FUN			; Function
	jnz	cc_19
	cmp	edi, [MaxFnBuffer]
	jnc	cc_1D1
	mov	dl, [ecx]
	add	dl, 7
	mov	[edi], dx
	mov	[edi+2], eax
	add	edi, 6
	cmp	eax, OPR_NEG
	jz	cc_1A1
	call	DecodeOper			; Request '(' in function case
	jc	cc_182
	mov	ecx, O CurrentPrivLevel
	cmp	dl, OT_SBOPEN
	jz	cc_19
	stc
	mov	dl, ERR_SBOPENXP
cc_182:	ret
cc_19:	mov	dl, [ecx]			; Open sign
	add	[byte ecx], 7
	mov	ecx, O PrivLevelStack
	inc	[dword ecx]
	mov	eax, [ecx]
	mov	[eax], dl
	cmp	dl, MAXPRIVLEVEL-7
	jnc	cc_1F
cc_1A:	clc
	ret

cc_1A1:	add	[byte ecx], 7
	jmp	cc_1A

cc_1B:	mov	ecx, O PrivLevelStack		; Close sign
	mov	eax, [ecx]
	dec	[dword ecx]
	mov	al, [eax]
	mov	[CurrentPrivLevel], al
	jmp	cc_1A

cc_1C:	mov	dl, 0				; Operand
cc_1D:	cmp	edi, [MaxFnBuffer]
	jnc	cc_1D1
	mov	[edi], dx
	mov	[edi+2], eax
	add	edi, 6
	jmp	cc_1A

cc_1D1:	mov	dl, ERR_FNBUFOVER		; FnBuffer full
	stc
	ret

cc_1E:	mov	dl, [OpLevels+eax]		; Operator
	cmp	dl, 0
	jnz	cc_20
	add	[byte ecx], 7
	cmp	[byte ecx], MAXPRIVLEVEL
	jc	cc_20
cc_1F:	stc
	mov	dl, ERR_TOOMANYBRCK
	ret
cc_20:	add	dl, [ecx]
	jmp	cc_1D
endp

;******************************************************************************
;
;	Bracket		Reads an expression ended with an endsign (ET_CLOSE)
;
;	in	esi - text pointer
;		edi - fn buffer
;	out	cf  - (bool)error
;		dx  - end sign type
;	destr	eax
;
;******************************************************************************

proc	Bracket
	jmp	lb_231

lb_22:	call	DecodeOper			; operator / close sign
	jc	lb_29
	cmp	dl, OT_SBCLOSE
	jz	lb_291
	cmp	dh, ET_CLOSE
	jz	lb_29
	cmp	dh, ET_EXECUTABLE
	jnz	lb_27
	cmp	al, FIRSTASSIGNMENT
	jc	lb_23
	test	[byte LastOper+1], ET_WRITABLE
	jz	lb_281
lb_23:	call	AddOper
	jc	lb_29

lb_231:	call	DecodeOper			; operand
	jc	lb_29
	cmp	dh, ET_EXECUTABLE
	jnz	lb_24

	cmp	eax, OPR_SUB			; negation
	jnz	lb_26
	mov	eax, OPR_NEG
	mov	dx, (ET_OPEN shl 8)+OT_FUN
	call	AddOper
	jc	lb_29

	call	DecodeOper			; after negation sign
	cmp	dl, OT_SBOPEN
	jz	lb_241

lb_24:	cmp	dh, ET_OPEN			; operand - bracket
	jnz	lb_25
	cmp	dl, OT_WBOPEN
	jz	lb_26
	call	AddOper
	jc	lb_29
lb_241:	call	Bracket
	jc	lb_29
	cmp	dl, OT_SBCLOSE
	jnz	lb_28
	jmp	lb_22

lb_25:	test	dh, ET_RW			; operand - variable
	jz	lb_26
	test	dh, ET_READABLE			; force = after writeonly
	jnz	lb_251
	push	esi
	push	eax
	push	edx
	call	DecodeOper
	cmp	dh, ET_EXECUTABLE
	jnz	lb_252
	cmp	al, FIRSTASSIGNMENT
	jc	lb_252
	pop	edx
	pop	eax
	pop	esi
	mov	[CurrentOper], dx
lb_251:	call	AddOper
	jc	lb_29
	jmp	lb_22

lb_252:	add	esp, 12
	mov	dl, ERR_OPRAXP
	stc
	ret

lb_26:	mov	dl, ERR_OPERANDXP
	stc
	ret

lb_27:	mov	dl, ERR_OPERATORXP
	stc
	ret

lb_28:	mov	dl, ERR_SBCLOSEXP
	stc
	ret

lb_281:	mov	dl, ERR_WRITABLEXP
	dec	esi
	stc
lb_29:	ret
lb_291:	call	AddOper		; Close bracket
	ret
endp

;******************************************************************************
;
;	EncodeExpr		Changes priorited code into executable code
;
;	in	esi - fn buffer
;		dl  - lowest priv level (saved)
;		edi - exec buffer
;	destr	eax
;		ebx
;
;******************************************************************************

proc	EncodeExpr
lb_2A:	cmp	edi, [MaxExecBuf]
	jc	lb_2A2
	mov	dl, ERR_EXECBUFOVER
	stc
	ret
lb_2A2:	mov	al, [esi]			; Determine type
	cmp	al, -1
	jz	lb_2C
	cmp	al, 0
	jz	lb_2B

	cmp	al, dl				; Operator
	ja	lb_2A4
	clc
	ret
lb_2A4:	cmp	[dword esi+2], OPR_A
	jnz	lb_2A3
	sub	edi, 8
lb_2A3:	push	edx
	push	esi
	add	esi, 6
	mov	dl, al
	call	EncodeExpr
	jc	lb_2B1
	pop	ebx
	pop	edx
	mov	eax, [ebx+2]
	cmp	eax, OPR_A
	jz	lb_2A1
	mov	eax, [OpAddr+eax*4]
	stosd
lb_2A1:	cmp	[byte ebx+2], FIRSTASSIGNMENT	; Assignment operator
	jc	lb_2A
	sub	ebx, 4
	mov	eax, O StoreVar
	stosd
	mov	eax, [ebx]
	stosd
	jmp	lb_2A

lb_2B:	mov	eax, O LoadVar			; Variable
	stosd
	mov	eax, [esi+2]
	stosd
	add	esi, 6
	jmp	lb_2A

lb_2B1:	add	esp, 8

lb_2C:	ret
endp

;******************************************************************************
;
;	CompileSingleExpr	Changes user expression into executable code
;
;	in	esi - text pointer
;		edi - exec buffer
;	out	dl - finishing char type ( OT_... )
;
;******************************************************************************

proc	CompileSingleExpr uses eax ebx
	push	edi				; Interpret
	mov	edi, [FnBuffer]
	mov	[LastOper], 0
	mov	[CurrentOper], 0
	mov	[CurrentPrivLevel], 0
	mov	[PrivLevelStack], O PrivLevels
	call	Bracket
	mov	[byte edi], -1
	pop	edi
	jc	lb_2D
	push	esi				; Compile
	push	edx
	mov	esi, [FnBuffer]
	xor	edx, edx
	call	EncodeExpr
	jc	lb_2D1
	pop	edx
	pop	esi
	cmp	[BooleanFlag], 0		; Remove result from stack
	jnz	lb_2D
	mov	eax, O RemoveResult
	call	SendToExecBuf
lb_2D:	ret
lb_2D1:	pop	esi
	pop	esi
	jmp	lb_2D
endp

;******************************************************************************
;
;	CompileMultipleExpr	Changes user expression chain into exec code
;
;	in	esi - text pointer
;		edi - exec buffer
;	out	dl - finishing char type ( OT_... )
;		cf  - (bool)error
;			dl  - error code
;			ebx - start of wrong expression
;			esi - after end of wrong expression
;	destr	ebx
;
;******************************************************************************

proc	CompileMultipleExpr
lb_2E:	mov	ebx, esi			; Determine expression type
	call	DecodeOper
	jc	lb_30
	cmp	dh, ET_CLOSE
	jz	lb_34
	cmp	dl, OT_VALUE
	jz	lb_33
	test	dh, ET_WRITABLE
	jnz	lb_31
	cmp	dl, OT_RESERVED
	jz	lb_35
	cmp	dl, OT_WBOPEN
	jz	lb_32
	mov	dl, ERR_EXPRXP
lb_2F:	stc
lb_30:	ret

lb_31:	call	DecodeOper			; Normal expression
	jc	lb_30
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_OPRAXP
	jnz	lb_2F
	cmp	al, OPR_A
	jc	lb_2F
	mov	esi, ebx
	call	CompileSingleExpr
	jc	lb_30
	cmp	dl, OT_END1
	jz	lb_2E
	clc
	jmp	lb_30

lb_32:	call	CompileMultipleExpr		; Subexpressions
	jc	lb_30
	cmp	dl, OT_WBCLOSE
	jz	lb_2E
	mov	dl, ERR_WBCLOSEXP
	jmp	lb_2F

lb_33:	mov	ebx, eax			; Value assignment
	call	DecodeOper				; val = number;
	jc	lb_30
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_OPRAXP
	jnz	lb_2F
	cmp	al, OPR_A
	jnz	lb_2F
	call	DecodeOper				; number
	jc	lb_30
	mov	cl, 0
	cmp	dl, OT_NUMBER
	jz	lb_331
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_NUMBERXP
	jnz	lb_2F
	cmp	al, OPR_SUB
	jnz	lb_2F
	mov	cl, 1
	call	DecodeOper
	jc	lb_30
	cmp	dl, OT_NUMBER
	mov	dl, ERR_NUMBERXP
	jnz	lb_2F
lb_331:	call	DecodeOper				; semicolon
	jc	lb_30
	cmp	dh, ET_CLOSE
	mov	dl, ERR_SEMICXP
	jnz	lb_2F
	mov	eax, O NumTableEnd			; assign number
	sub	[dword eax], 10
	mov	eax, [eax]
	fld	[tbyte eax]
	cmp	cl, 0
	jz	lb_332
	fchs
lb_332:	fstp	[tbyte ebx]
	jmp	lb_2E

lb_34:	cmp	dl, OT_END1			; End sign or ';'
	jz	lb_2E
	clc
	jmp	lb_30

lb_35:	mov	dl, ERR_EXPRXP			; Reserved word
	cmp	al, LASTRESERVED
	ja	lb_2F
	cmp	al, RES_ELSE
	jz	lb_2F
	jmp	[ResWords+eax*4]

res_if:
	call	StartBlockExpr
	jc	lb_30
	call	CompileCommonConditional, 0	; if ~(S)~ E
	jc	lb_30
	call	CompileSingleOrMultiple		; if (S) ~E~
	jc	lb_30
	cmp	dl, OT_WBCLOSE
	jnz	lb_37
	call	DecodeOper
	jc	lb_30
lb_37:	cmp	dl, OT_END1
	mov	dl, ERR_SEMICXP
	jnz	lb_2F
	push	esi				; if (S) E ~else~ E
	call	DecodeOper
	mov	dh, al
	pop	eax
	jc	lb_30
	cmp	dl, OT_RESERVED
	jnz	lb_38
	cmp	dh, RES_ELSE
	jz	lb_39
lb_38:	mov	esi, eax
	call	RealizeConditional
	jmp	lb_3A
lb_39:	call	AddBreak, 1
	jc	lb_30
	call	RealizeConditional
	call	CompileSingleOrMultiple		; if (S) E else ~E~
	jc	lb_30
lb_3A:	call	FinishBlockExpr
	jmp	lb_2E

res_while:
	call	StartBlockExpr
	jc	lb_30
	call	CompileCommonConditional, 0	; while ~(S)~ E
	jc	lb_30
	call	CompileSingleOrMultiple		; while (S) ~E~
	jc	lb_30
	call	AddBreak, 0
	jc	lb_30
	call	RealizeConditional
	call	FinishBlockExpr
	jmp	lb_2E

res_do:
	call	StartBlockExpr
	jc	lb_30
	call	RealizeConditional
	call	CompileSingleOrMultiple		; do ~E~ while (S)
	jc	lb_30
	call	DecodeOper			; do E ~while~ (S)
	jc	lb_30
	cmp	dl, OT_RESERVED
	mov	dl, ERR_WHILEXP
	jnz	lb_2F
	cmp	al, RES_WHILE
	jnz	lb_2F
	call	CompileCommonConditional, 1	; do E while ~(S)~
	jc	lb_30
	call	FinishBlockExpr
	jmp	lb_2E

res_for:
	call	DecodeOper			; for ~(~M,S,M) E;
	jc	lb_30
	cmp	dl, OT_SBOPEN
	mov	dl, ERR_SBOPENXP
	jnz	lb_2F
	call	CompileMultipleExpr		; for (~M,~S,M) E;
	jc	lb_30
	cmp	dl, OT_END2
	mov	dl, ERR_COMMAXP
	jnz	lb_2F
	call	AddJump
	jc	lb_30
	push	eax
	call	StartBlockExpr
	jc	lb_3F
	mov	[BooleanFlag], 1		; for (M,~S,~M) E;
	call	CompileSingleExpr
	mov	[BooleanFlag], 0
	jc	lb_3F
	cmp	dl, OT_END2
	mov	dl, ERR_COMMAXP
	jnz	lb_3F
	call	AddConditionalJump, 0
	jc	lb_3F
	call	AddJump
	jc	lb_3F
	push	eax
	push	edi
	call	CompileMultipleExpr		; for (M,S,~M)~ E;
	jc	lb_3E
	cmp	dl, OT_SBCLOSE
	mov	dl, ERR_SBCLOSEXP
	jnz	lb_3E
	call	AddBreak, 0
	jc	lb_3E
	pop	edx
	pop	eax
	mov	[eax], edi
	pop	eax
	mov	[eax], edi
	push	edx
	call	CompileSingleOrMultiple		; for (M,S,M) ~E~;
	jc	lb_3F
	call	AddJump
	jc	lb_3F
	pop	[dword eax]
	call	RealizeConditional
	call	FinishBlockExpr
	jmp	lb_2E
lb_3E:	pop	eax
	pop	eax
lb_3F:	pop	eax
	jmp	lb_2F

res_break:
	call	AddBreak, 1			; break
	jnc	lb_2E
	ret

res_return:
	xor	eax, eax			; return
	call	SendToExecBuf
	jnc	lb_2E
	ret

res_main:
	cmp	[BlockStart], 0			; main
	mov	dl, ERR_MAININ
	jnz	lb_2F
	cmp	[MainAddr], 0
	mov	dl, ERR_SECONDMAIN
	jnz	lb_2F
	xor	eax, eax
	call	SendToExecBuf
	jc	lb_30
	mov	[MainAddr], edi
	jmp	lb_2E
endp

proc	AddBreak uses eax ecx, BEnd
	cmp	[BlockStart], 0
	jz	lb_421
	call	AddJump
	jc	lb_422
	cmp	[BEnd], 0
	jz	lb_42
	mov	ecx, [BreakTableEnd]
	cmp	ecx, [MaxBreakTableEnd]
	jnc	lb_423
	mov	[ecx], eax
	add	[BreakTableEnd], 4
	ret
lb_42:	mov	ecx, [BlockStart]
	mov	ecx, [ecx]
	mov	[eax], ecx
	ret
lb_423:	mov	dl, ERR_TMANYBREAKS
	jmp	lb_422
lb_421:	mov	dl, ERR_BREAKOUT
	stc
lb_422:	ret
endp

proc	AddJump
	mov	eax, O JumpCode
	call	SendToExecBuf
	jc	lb_424
	mov	eax, edi
	call	SendToExecBuf
lb_424:	ret
endp

proc	CompileSingleOrMultiple uses eax
	push	esi
	call	DecodeOper
	pop	eax
	jc	lb_43
	cmp	dl, OT_WBOPEN
	jz	lb_44

	mov	esi, eax
	call	CompileSingleExpr

lb_43:	ret

lb_44:	call	CompileMultipleExpr
	jc	lb_43
	cmp	dl, OT_WBCLOSE
	jz	lb_43
	cmp	dl, OT_END1
	mov	dl, ERR_WBCLOSEXP
	stc
	jnz	lb_43
	call	DecodeOper
	jc	lb_43
	cmp	dl, OT_WBCLOSE
	jz	lb_43
	mov	dl, ERR_WBCLOSEXP
	stc
	ret
endp

proc	AddConditionalJump uses eax ecx, Bool
	cmp	edi, [MaxExecBuf]
	jc	lb_451
	mov	dl, ERR_EXECBUFOVER
	stc
	ret
lb_451:	mov	eax, O TrueCode
	cmp	[Bool], 0
	jnz	lb_45
	mov	eax, O FalseCode
lb_45:	stosd
	mov	eax, edi
	stosd
	mov	ecx, [BlockStart]
	mov	[ecx+4], eax
	clc
	ret
endp

proc	CompileCommonConditional, Bool
	call	DecodeOper
	jc	lb_46
	cmp	dl, OT_SBOPEN
	mov	dl, ERR_SBOPENXP
	jnz	lb_46
	mov	[BooleanFlag], 1
	call	CompileSingleExpr
	mov	[BooleanFlag], 0
	jc	lb_46
	cmp	dl, OT_SBCLOSE
	mov	dl, ERR_SBCLOSEXP
	jnz	lb_46
	call	AddConditionalJump, [Bool]
	ret
lb_46:	stc
	ret
endp

proc	SendToExecBuf
	cmp	edi, [MaxExecBuf]
	cmc
	jnc	lb_462
	mov	dl, ERR_EXECBUFOVER
	ret
lb_462:	stosd
	ret
endp

proc	RealizeConditional uses eax
	mov	eax, [BlockStart]
	mov	[eax+8], edi
	ret
endp

proc	StartBlockExpr uses eax ecx
	mov	eax, [BlockStart]
	mov	ecx, [BreakTableEnd]
	cmp	ecx, [MaxBreakTableEnd]
	mov	dl, ERR_TMANYBLOCKS
	cmc
	jc	lb_461
	mov	[ecx], eax
	lea	eax, [ecx+4]
	mov	[BlockStart], eax
	mov	[eax], edi
	xor	ecx, ecx
	mov	[eax+4], ecx
	mov	[eax+8], ecx
	add	eax, 12
	mov	[BreakTableEnd], eax
lb_461:	ret
endp

proc	FinishBlockExpr uses eax ecx edx
	mov	eax, [BlockStart]
	mov	ecx, [eax+4]
	mov	edx, [eax+8]
	mov	[ecx], edx
	add	eax, 12
	mov	ecx, [BreakTableEnd]
lb_47:	cmp	eax, ecx
	jnc	lb_48
	mov	edx, [eax]
	mov	[edx], edi
	add	eax, 4
	jmp	lb_47
lb_48:	mov	eax, [BlockStart]
	sub	eax, 4
	mov	[BreakTableEnd], eax
	mov	eax, [eax]
	mov	[BlockStart], eax
	ret
endp

;******************************************************************************
;
;	ExecutableCode		Code that really will be executed
;
;******************************************************************************

proc	ExecutableCode
opr_add:
	call	DoubleArg
	faddp	st(1), st
opr_null:
	ret
opr_sub:
	call	DoubleArg
	fsubp	st(1), st
	ret
opr_mul:
	call	DoubleArg
	fmulp	st(1), st
	ret
opr_div:
	call	DoubleArg
	call	ZeroCheck
	jc	opr_error
	fdivp	st(1), st
	ret
opr_mod:
	call	DoubleArg
	call	ZeroCheck
	jc	opr_error
	call	IntegerCheck
	jc	opr_error
	fxch	st(1)
	fprem
	fstp	st(1)
	ret
opr_pwr:
	call	DoubleArg
	fxch	st(1)
	fabs
	fyl2x
	call	f2x
	ret
opr_shl:
	call	DoubleArg
opr_1:	fxch	st(1)
	fscale
	fstp	st(1)
	ret
opr_shr:
	call	DoubleArg
	fchs
	jmp	opr_1
opr_l:
	call	DoubleArg
	fcompp
	fstsw	ax
	test	ah, 45h
	jz	opr_true
	jmp	opr_false
opr_g:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 01h
	jz	opr_true
	jmp	opr_false
opr_e:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	opr_true
	jmp	opr_false
opr_le:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 01h
	jnz	opr_true
	jmp	opr_false
opr_ge:
	call	DoubleArg
	fcompp
	fstsw	ax
	test	ah, 45h
	jnz	opr_true
	jmp	opr_false
opr_ne:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_and:
	call	DoubleArg
	fcomp	st(1)
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4A
	ffree	st
	fincstp
	jmp	opr_false
lb_4A:	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_or:
	call	DoubleArg
	fcomp	st(1)
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4B
	ffree	st
	fincstp
	jmp	opr_true
lb_4B:	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_true:
	fld1
	ret
opr_false:
	fldz
	ret

opr_neg:
	call	SingleArg
	fchs
	ret
opr_abs:
	call	SingleArg
	fabs
	ret
opr_sin:
	call	SingleArg
	fsin
	ret
opr_cos:
	call	SingleArg
	fcos
	ret
opr_atan:
	call	SingleArg
	fld1
	fpatan
	ret
opr_log:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	ret
opr_ln:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	fldl2e
	fdivp	st(1), st
	ret
opr_lg:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	fldl2t
	fdivp	st(1), st
	ret
opr_sqrt:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fsqrt
	ret
opr_frac:
	call	SingleArg
	fld	st
	frndint
	fsubp	st(1), st
	ret
opr_exp:
	call	SingleArg
	fldl2e
	fmulp	st(1), st
	call	f2x
	ret
opr_error:
	add	esp, 4
	stc
	ret
endp

proc	SingleArg
	mov	eax, O StackTop
	sub	[dword eax], 10
	mov	eax, [eax]
	fld	[tbyte eax]
	pop	eax
	push	O EndOper
	jmp	eax
endp

proc	DoubleArg
	mov	eax, [StackTop]
	sub	eax, 20
	fld	[tbyte eax]
	fld	[tbyte eax+10]
	mov	[StackTop], eax
	pop	eax
	push	O EndOper
	jmp	eax
endp

proc	EndOper
	mov	eax, [StackTop]
	add	[StackTop], 10
	fstp	[tbyte eax]
	ret
endp

proc	RemoveResult
	sub	[StackTop], 10
	ret
endp

proc	f2x
	fld	st
	frndint
	fsub	st(1), st
	fld1
	fscale
	fstp	st(1)
	fxch	st(1)
	f2xm1
	fld1
	faddp	st(1), st
	fmulp	st(1), st
	ret
endp

proc	PositiveCheck
	cmp	[FriendlySyntax], 0
	jnz	lb_4D
	fxam
	fstsw	ax
	test	ah, 02h
	jz	lb_4E
	mov	dl, ERR_NEGATIVEVAL
	stc
	ret
lb_4D:	fabs
lb_4E:	ret
endp

proc	ZeroCheck
	ftst
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	clc
	jnz	lb_4E
	cmp	[FriendlySyntax], 0
	jnz	lb_4F
	mov	dl, ERR_DIVBYZERO
	stc
	ret
lb_4F:	ffree	st
	fincstp
	fld	st
	ret
endp

proc	IntegerCheck
	cmp	[FriendlySyntax], 0
	clc
	jnz	lb_4E
	fld	st
	frndint
	fsubr	st, st(1)
	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4E
	mov	dl, ERR_INTEGERXP
	stc
	ret
endp

proc	StoreVar
	lodsd
	mov	edi, eax
	push	esi
	mov	esi, [StackTop]
	mov	ecx, 10
	sub	esi, ecx
	rep	movsb
	pop	esi
	clc
	ret
endp

proc	LoadVar
	mov	edi, [StackTop]
	cmp	edi, [MaxStackTop]
	mov	dl, ERR_STACKOVER
	cmc
	jc	lb_4F2
	lodsd
	push	esi
	mov	esi, eax
	mov	ecx, 5
	rep	movsw
	mov	[StackTop], edi
	pop	esi
	clc
lb_4F2:	ret
endp

proc	JumpCode
	lodsd
	mov	esi, eax
	clc
	ret
endp

proc	GetBoolResult
	mov	edi, O StackTop
	mov	ecx, 10
	sub	[edi], ecx
	mov	edi, [edi]
	mov	al, 0
	repz	scasb
	setnz	al
	shr	al, 1
	lodsd
	ret
endp

proc	TrueCode
	call	GetBoolResult
	jnc	lb_4F1
	mov	esi, eax
lb_4F1:	clc
	ret
endp

proc	FalseCode
	call	GetBoolResult
	jc	lb_4F1
	mov	esi, eax
	ret
endp

;******************************************************************************
;
;	Compile		Main function that compiles all expressions
;
;	out	cf  - (bool)error
;			dl - error code
;
;******************************************************************************

proc	Compile
	mov	esi, O StdOpers			; Fill initial Opers buffer
	mov	edi, [Opers]
	mov	ecx, O StdOpersEnd - O StdOpers
	cld
	rep	movsb

	xor	eax, eax			; Prepare to compilation
	mov	[MainAddr], eax
	mov	[BlockStart], eax
	mov	[BooleanFlag], al
	mov	eax, [Opers]
	add	eax, [OpersSize]
	sub	eax, 12
	mov	[MaxOpers], eax
	mov	eax, [NumTable]
	mov	[NumTableEnd], eax
	add	eax, [NumTableSize]
	sub	eax, 12
	mov	[MaxNumTable], eax
	mov	eax, [ExecBuffer]
	add	eax, [ExecBufferSize]
	sub	eax, 12
	mov	[MaxExecBuf], eax
	mov	eax, [FnBuffer]
	add	eax, [FnBufferSize]
	sub	eax, 12
	mov	[MaxFnBuffer], eax
	mov	eax, [ExecStack]
	mov	[StackTop], eax
	add	eax, [ExecStackSize]
	sub	eax, 12
	mov	[MaxStackTop], eax
	mov	eax, [BreakTable]
	mov	[BreakTableEnd], eax
	add	eax, [BreakTableSize]
	sub	eax, 12
	mov	[MaxBreakTableEnd], eax
	mov	eax, [UserBuffer]
	add	eax, [UserBufferSize]
	mov	[UserBufferEnd], eax

	mov	esi, [UserBuffer]
	mov	edi, [ExecBuffer]

lb_50:	call	CompileMultipleExpr		; Compile
	jc	lb_51
	cmp	dl, OT_EOF
	jz	lb_51
	cmp	dl, OT_END1
	jz	lb_50
	mov	dl, ERR_SEMICXP
	stc

lb_51:	mov	[dword edi], 0
	ret
endp

;******************************************************************************
;
;	Execute		Executes function (initial or main)
;		Initial: 0 - main code, 1 - initial code
;
;	out	cf  - (bool)error
;			dl - error code
;
;******************************************************************************

proc	Execute uses eax ebx ecx, Initial
	mov	eax, [ExecStack]
	mov	[StackTop], eax
	cld
	mov	esi, [ExecBuffer]
	cmp	[Initial], 0
	jz	lb_52
	cmp	[MainAddr], 0
	jnz	lb_53
	ret
lb_52:	cmp	[MainAddr], 0
	jz	lb_53
	mov	esi, [MainAddr]
lb_53:	lodsd
	or	eax, eax
	jz	lb_54
	call	eax
	jc	lb_54
	jmp	lb_53
lb_54:	ret
endp
