ideal
p386
model small, stdcall

O equ <offset>

MAXPRIVLEVEL	= 7*20
FIRSTASSIGNMENT	= OPR_A

; Standard operator/operand types ( * - non-sign types )

OT_UNKNOWN	= 00h		; '$'
OT_NUMBER	= 11h		; '0'
OT_VAR		= 01h		; 'a'
OT_NEWVAR	= 02h	;*	; 'a'
OT_OPERATOR	= 03h		; '+'
OT_SBOPEN	= 04h		; '('
OT_SBCLOSE	= 05h		; ')'
OT_WBOPEN	= 06h		; '{'
OT_WBCLOSE	= 07h		; '}'
OT_END1		= 08h		; ';'
OT_END2		= 09h		; ','
OT_EOF		= 0Ah	;*	; '\0'
OT_RESERVED	= 0Bh	;*	; 'if'
OT_FUN		= 0Ch	;*	; 'sin'
OT_VALUE	= 0Dh	;*	; 'xmin'
OT_CONST	= 0Eh	;*	; 'pi'

; Extended operator/operand types

ET_RESERVED	=  0	; OT_RESERVED
ET_WRITABLE	=  1	; OT_NEWVAR, OT_VALUE
ET_READABLE	=  2	; OT_NUMBER, OT_CONST
ET_RW		=  3	; OT_VAR
ET_EXECUTABLE	=  4	; OT_OPERATOR
ET_OPEN		=  8	; OT_SBOPEN, OT_WBOPEN, OT_FUN
ET_CLOSE	= 16	; OT_SBCLOSE, OT_WBCLOSE, OT_END1, OT_END2, OT_EOF

; Operators

OPR_ADD		=  1	; +
OPR_SUB		=  2	; -
OPR_MUL		=  3	; *
OPR_DIV		=  4	; /
OPR_MOD		=  5	; %
OPR_PWR		=  6	; ^
OPR_SHL		=  7	; <<
OPR_SHR		=  8	; >>
OPR_L		=  9	; <
OPR_G		= 10	; >
OPR_E		= 11	; ==
OPR_LE		= 12	; <=
OPR_GE		= 13	; >=
OPR_NE		= 14	; !=
OPR_AND		= 15	; &&
OPR_OR		= 16	; ||

OPR_NEG		= 17	; -a
OPR_ABS		= 18	; abs()
OPR_SIN		= 19	; sin()
OPR_COS		= 20	; cos()
OPR_ATAN	= 21	; atan()
OPR_LOG		= 22	; log()
OPR_LN		= 23	; ln()
OPR_LG		= 24	; lg()
OPR_SQRT	= 25	; sqrt()
OPR_FRAC	= 26	; frac()
OPR_EXP		= 27	; exp()

OPR_A		= 28	; =
OPR_AADD	= 29	; +=
OPR_ASUB	= 30	; -=
OPR_AMUL	= 31	; *=
OPR_ADIV	= 32	; /=
OPR_AMOD	= 33	; %=
OPR_APWR	= 34	; ^=
OPR_ASHL	= 35	; <<=
OPR_ASHR	= 36	; >>=

; Reserved words

RES_IF		= 0
RES_ELSE	= 1
RES_WHILE	= 2
RES_DO		= 3
RES_FOR		= 4
RES_BREAK	= 5
RES_RETURN	= 6
RES_MAIN	= 7
LASTRESERVED	= RES_MAIN

; Error types

ERR_UNKNOWNSIGN	=  0	; Unknown sign
ERR_UNKNOWNOPER	=  1	; Unknown operator/operand
ERR_INVALIDNUM	=  2	; Invalid number format
ERR_TOOMANYBRCK	=  3	; Too many brackets
ERR_TOOMANYVARS	=  4	; Data buffer overflow
ERR_TMANYBREAKS	=  5	; Too many breaks
ERR_TMANYBLOCKS	=  6	; Too many block instructions
ERR_FNBUFOVER	=  7	; Conversion buffer overflow
ERR_EXECBUFOVER	=  8	; Executable buffer overflow
ERR_OPERANDXP	=  9	; Operand expected
ERR_OPERATORXP	= 10	; Operator expected
ERR_WRITABLEXP	= 11	; Writable variable expected
ERR_EXPRXP	= 12	; Expression expected
ERR_NUMBERXP	= 13	; Number expected
ERR_SBOPENXP	= 14	; '(' expected
ERR_SBCLOSEXP	= 15	; ')' expected
ERR_SEMICXP	= 16	; ';' expected
ERR_OPRAXP	= 17	; '=' expected
ERR_WBCLOSEXP	= 18	; '}' expected
ERR_COMMAXP	= 19	; ',' expected
ERR_WHILEXP	= 20	; 'while' expected
ERR_BREAKOUT	= 21	; Wrong break placement
ERR_MAININ	= 22	; Wrong main placement
ERR_SECONDMAIN	= 23	; Duplicate main label

ERR_NEGATIVEVAL	= 24	; Negative value
ERR_DIVBYZERO	= 25	; Division by zero
ERR_INTEGERXP	= 26	; Non-integer value
ERR_STACKOVER	= 27	; Stack overflow

dataseg

include "compdata.inc"

X		dt 0
Y		dt 0
Z		dt 0
P		dt 4005F6E978D4FDF3B646h	; 123.456
Q		dt 4004FECCCCCCCCCCCCCDh	; 63.7
T		dt 40018C6A7EF9DB22D0E5h	; 4.388
XMid		dt 0
YMid		dt 0
ZMid		dt 0
PMin		dt 0
PMax		dt 0
PGran		dt 0
QMin		dt 0
QMax		dt 0
QGran		dt 0
TMax		dt 0
XYZScale	dt 0
FriendlySyntax	db 1

label UserCode
include "test.inc"
label UserCodeEnd

Opers		dd O OpersBuffer
MaxOpers	dd O OpersBuffer + 988
NumTableEnd	dd O NumTable
MaxNumTable	dd O NumTable + 988
MaxBreakTableEnd dd O BreakTable + 988
MaxStackTop	dd O ExecStack + 988
MaxFnBuffer	dd O FnBuffer + 988
MaxExecBuf	dd O ExecBuffer + 988

udataseg

CurrentOper	dw ?
LastOper	dw ?
PrivLevels	db MAXPRIVLEVEL dup (?)
PrivLevelStack	dd ?
CurrentPrivLevel db ?
ExecBuffer	db 1000 dup (?)
FnBuffer	db 1000 dup (?)
OpersBuffer	db 1000 dup (?)
NumTable	db 1000 dup (?)
ExecStack	db 1000 dup (?)
BreakTable	db 1000 dup (?)
MainAddr	dd ?
BlockStart	dd ?
BreakTableEnd	dd ?
StackTop	dd ?
UserBufferEnd	dd ?
BooleanFlag	db ?

ProgramStack	db 1000 dup (?)
label StackPtr

codeseg

;******************************************************************************
;
;	DecodeOper		Changes user string into internal id
;
;	in	esi - pointer to text
;	out	eax - type specific data
;		dl  - operator/operand type
;		dh  - extended oper type
;		cf  - (bool)error
;
; struc Opers
;	byte  StrLength = C
;	char  Expr[C]
;	byte  Type
;	dword Data
;
;******************************************************************************

proc	DecodeOper uses ebx ecx edi
	mov	ecx, [UserBufferEnd]
	sub	ecx, esi
	jna	lb_02
lb_01:	lodsb					; Skip bytes with no meaning
	cmp	al, ' '
	jg	lb_04
	loop	lb_01

lb_02:	clc					; Return and signalize EOF
	mov	dl, OT_EOF
	jmp	lb_12

lb_03:	mov	edi, esi			; Skip comment
	mov	al, 13
	dec	ecx
	jz	lb_02
	repnz	scasb
	mov	esi, edi
	jz	lb_01
	jmp	lb_02

lb_04:	dec	esi				; Check if comment sign
	cmp	al, '#'
	jz	lb_03

	mov	ebx, O SignTypes		; Prepare to determine type
	mov	edi, esi
	xor	eax, eax

	lodsb					; Determine type
	sub	al, ' '
	mov	dl, [eax+ebx]
	cmp	dl, OT_NUMBER
	jz	lb_041
	cmp	dl, OT_SBOPEN
	jnc	lb_12
lb_041:	mov	dh, 0EFh
	cmp	dl, OT_VAR			; if first is OT_VAR
	jz	lb_06					; then treat OT_NUMBER
	mov	dh, 0FFh				; like OT_VAR
	cmp	dl, OT_UNKNOWN
	jnz	lb_06
	stc
	jmp	lb_12
lb_05:	lodsb
	sub	al, ' '
	jle	lb_07
	mov	al, [eax+ebx]
	and	al, dh
	cmp	dl, al
	jnz	lb_07
lb_06:	loop	lb_05
	inc	esi

lb_07:	mov	ebx, edi			; Calculate length
	dec	esi
	neg	edi
	add	edi, esi			; Save new position
	push	esi
	mov	al, dl
	mov	edx, edi
	cmp	al, OT_NUMBER
	jz	lb_0E

	mov	edi, [Opers]			; Find oper in storage
lb_08:	movzx	ecx, [byte edi]
	inc	edi
	test	cl, cl
	jz	lb_0A
	cmp	cl, dl
	jnz	lb_09
	mov	esi, ebx
	repz	cmpsb
	jz	lb_0C
lb_09:	lea	edi, [edi+ecx+5]		; Skip expression
	jmp	lb_08

lb_0A:	cmp	al, OT_VAR			; If variable - new operand
	jnz	lb_0D
	push	eax
	movzx	eax, dl
	add	eax, [Opers]
	add	eax, 6
	cmp	eax, [MaxOpers]
	pop	eax
	jc	lb_0A1
	mov	dl, ERR_TOOMANYVARS
	stc
	jmp	lb_0B
lb_0A1:	mov	[edi-1], dl			; Add new variable to list
	mov	esi, ebx
	mov	cl, dl
	rep	movsb
	stosb
	mov	dl, OT_NEWVAR
	call	PushNumTable
	jc	lb_0B
	stosd
	mov	[byte edi], 0
lb_0B:	pop	esi
	jmp	lb_12

lb_0C:	mov	dl, [edi]			; Return expr type and data
	mov	eax, [edi+1]
	clc
	jmp	lb_0B

lb_0D:	stc					; Signalize variable
	mov	dl, ERR_UNKNOWNOPER
	jmp	lb_0B

lb_0E:	fldz					; Find comma
	mov	edi, ebx
	mov	ecx, edx
	mov	al, '.'
	repnz	scasb
	jnz	lb_10
	ffree	st
	sub	edx, ecx
	dec	edx

	mov	esi, edi			; If more than one comma exists
	push	ecx				;  return error
	repnz	scasb
	pop	ecx
	jnz	lb_0F
	mov	dl, ERR_INVALIDNUM
	stc
	jmp	lb_0B

lb_0F:	fldl2t					; Decode fraction
	push	ecx
	fild	[dword esp]
	add	esp, 4
	fmulp	st(1), st
	call	f2x
	call	LoadNumber
	jc	lb_11
	fdivrp	st(1), st

lb_10:	mov	esi, ebx			; Decode integer part
	mov	ecx, edx
	call	LoadNumber
	jc	lb_11
	faddp	st(1), st

	call	PushNumTable			; Return number
	jc	lb_0B
	fstp	[tbyte eax]
	mov	dl, OT_NUMBER
	clc
	jmp	lb_0B

lb_11:	ffree	st
	mov	dl, ERR_INVALIDNUM
	jmp	lb_0B

lb_12:	movzx	ebx, dl				; Get extended type
	mov	dh, [ExTypes+ebx-1]
	mov	bx, dx
	xchg	bx, [CurrentOper]
	mov	[LastOper], bx
	ret
endp

;******************************************************************************
;
;	PushNumTable		Allocates more space on NumTable stack
;
;	out	eax - new address
;	destr	ecx
;		edi
;
;******************************************************************************

proc	PushNumTable
	mov	ecx, O NumTableEnd
	mov	eax, [MaxNumTable]
	cmp	[ecx], eax
	jc	lb_121
	mov	dl, ERR_TOOMANYVARS
	stc
	ret
lb_121:	mov	eax, [ecx]
	add	[dword ecx], 10
	mov	ecx, -1
	mov	[eax], ecx
	mov	[eax+4], ecx
	mov	[eax+8], cx
	ret
endp

;******************************************************************************
;
;	LoadNumber		Internal function of DecodeOper
;
;	in	ecx - character count
;		esi - text-number address
;	out	st  - encoded integer number
;		cf  - (bool)error
;	destr	eax
;		edi
;
;******************************************************************************

proc	LoadNumber
	jecxz	lb_13				; Prepare to conv number to BCD
	cmp	ecx, 10
	jna	lb_14
lb_13:	stc
	ret
lb_14:	xor	eax, eax
	push	eax
	push	eax
	push	eax
	mov	edi, esp
	lea	esi, [esi+ecx-1]
	mov	al, -1

lb_15:	mov	ah, al				; Convert number to BCD
	mov	al, [esi]
	dec	esi
	sub	al, '0'
	cmp	ah, -1
	jz	lb_17
	shl	al, 4
	or	al, ah
	stosb
	mov	al, -1
lb_17:	loop	lb_15
	cmp	al, -1
	jz	lb_18
	stosb

lb_18:	fbld	[tbyte esp]			; Load number to st
	add	esp, 12
	clc
	ret
endp

;******************************************************************************
;
;	AddOper		Inserts decoded oper into operation code buffer
;
;	in	dx  - type
;		eax - data
;		edi - fn buffer
;	out	cf  - (bool)error
;
; struc FnBuffer
;	byte  PrivLevel ( 0 - var )
;	byte  ExType ( ET_OPEN - function )
;	dword Data ( data ptr for var, id for operator/fun )
;
;******************************************************************************

proc	AddOper uses ecx
	mov	ecx, O CurrentPrivLevel
	cmp	dh, ET_EXECUTABLE		; Determine type
	jz	lb_1E
	cmp	dh, ET_CLOSE
	jz	lb_1B
	cmp	dh, ET_OPEN
	jnz	lb_1C

	cmp	dl, OT_FUN			; Function
	jnz	lb_19
	cmp	edi, [MaxFnBuffer]
	jnc	lb_1D1
	mov	dl, [ecx]
	add	dl, 7
	mov	[edi], dx
	mov	[edi+2], eax
	add	edi, 6
	cmp	eax, OPR_NEG
	jz	lb_1A
	call	DecodeOper			; Request '(' in function case
	jc	lb_182
	mov	ecx, O CurrentPrivLevel
	cmp	dl, OT_SBOPEN
	jz	lb_19
	stc
	mov	dl, ERR_SBOPENXP
lb_182:	ret
lb_19:	mov	dl, [ecx]			; Open sign
	add	[byte ecx], 7
	mov	ecx, O PrivLevelStack
	inc	[dword ecx]
	mov	eax, [ecx]
	mov	[eax], dl
	cmp	dl, MAXPRIVLEVEL-7
	jnc	lb_1F
lb_1A:	clc
	ret

lb_1B:	mov	ecx, O PrivLevelStack		; Close sign
	mov	eax, [ecx]
	dec	[dword ecx]
	mov	al, [eax]
	mov	[CurrentPrivLevel], al
	jmp	lb_1A

lb_1C:	mov	dl, 0				; Operand
lb_1D:	cmp	edi, [MaxFnBuffer]
	jnc	lb_1D1
	mov	[edi], dx
	mov	[edi+2], eax
	add	edi, 6
	jmp	lb_1A

lb_1D1:	mov	dl, ERR_FNBUFOVER		; FnBuffer full
	stc
	ret

lb_1E:;	cmp	dl, FIRSTASSIGNMENT		; Operator
	mov	dl, [OpLevels+eax]
;	jnc	lb_1E1
	cmp	dl, 0
	jnz	lb_20
lb_1E1:	add	[byte ecx], 7
	cmp	[byte ecx], MAXPRIVLEVEL
	jc	lb_20
lb_1F:	stc
	mov	dl, ERR_TOOMANYBRCK
	ret
lb_20:	add	dl, [ecx]
	jmp	lb_1D
endp

;******************************************************************************
;
;	Bracket		Reads an expression ended with an endsign (ET_CLOSE)
;
;	in	esi - text pointer
;		edi - fn buffer
;	out	cf  - (bool)error
;		dx  - end sign type
;	destr	eax
;
;******************************************************************************

proc	Bracket
	jmp	lb_231

lb_22:	call	DecodeOper			; operator / close sign
	jc	lb_29
	cmp	dl, OT_SBCLOSE
	jz	lb_291
	cmp	dh, ET_CLOSE
	jz	lb_29
	cmp	dh, ET_EXECUTABLE
	jnz	lb_27
	cmp	al, FIRSTASSIGNMENT
	jc	lb_23
	test	[byte LastOper+1], ET_WRITABLE
	jz	lb_281
lb_23:	call	AddOper
	jc	lb_29

lb_231:	call	DecodeOper			; operand
	jc	lb_29
	cmp	dh, ET_EXECUTABLE
	jnz	lb_24

	cmp	eax, OPR_SUB			; negation
	jnz	lb_26
	mov	eax, OPR_NEG
	mov	dx, (ET_OPEN shl 8)+OT_FUN
	call	AddOper
	jc	lb_29

	call	DecodeOper			; after negation sign
	cmp	dl, OT_SBOPEN
	jz	lb_241

lb_24:	cmp	dh, ET_OPEN			; operand - bracket
	jnz	lb_25
	cmp	dl, OT_WBOPEN
	jz	lb_26
	call	AddOper
	jc	lb_29
lb_241:	call	Bracket
	jc	lb_29
	cmp	dl, OT_SBCLOSE
	jnz	lb_28
	jmp	lb_22

lb_25:	test	dh, ET_RW			; operand - variable
	jz	lb_26
	call	AddOper
	jc	lb_29
	jmp	lb_22

lb_26:	mov	dl, ERR_OPERANDXP
	stc
	ret

lb_27:	mov	dl, ERR_OPERATORXP
	stc
	ret

lb_28:	mov	dl, ERR_SBCLOSEXP
	stc
	ret

lb_281:	mov	dl, ERR_WRITABLEXP
	dec	esi
	stc
lb_29:	ret
lb_291:	call	AddOper		; Close bracket
	ret
endp

;******************************************************************************
;
;	EncodeExpr		Changes priorited code into executable code
;
;	in	esi - fn buffer
;		dl  - lowest priv level (saved)
;		edi - exec buffer
;	destr	eax
;		ebx
;
;******************************************************************************

proc	EncodeExpr
lb_2A:	cmp	edi, [MaxExecBuf]
	jc	lb_2A2
	mov	dl, ERR_EXECBUFOVER
	stc
	ret
lb_2A2:	mov	al, [esi]			; Determine type
	cmp	al, -1
	jz	lb_2C
	cmp	al, 0
	jz	lb_2B

	cmp	al, dl				; Operator
	ja	lb_2A4
	clc
	ret
lb_2A4:	cmp	[dword esi+2], OPR_A
	jnz	lb_2A3
	sub	edi, 8
lb_2A3:	push	edx
	push	esi
	add	esi, 6
	mov	dl, al
	call	EncodeExpr
	jc	lb_2B1
	pop	ebx
	pop	edx
	mov	eax, [ebx+2]
	cmp	eax, OPR_A
	jz	lb_2A1
	mov	eax, [OpAddr+eax*4]
	stosd
lb_2A1:	cmp	[byte ebx+2], FIRSTASSIGNMENT	; Assignment operator
	jc	lb_2A
	sub	ebx, 4
	mov	eax, O StoreVar
	stosd
	mov	eax, [ebx]
	stosd
	jmp	lb_2A

lb_2B:	mov	eax, O LoadVar			; Variable
	stosd
	mov	eax, [esi+2]
	stosd
	add	esi, 6
	jmp	lb_2A

lb_2B1:	add	esp, 8

lb_2C:	ret
endp

;******************************************************************************
;
;	CompileSingleExpr	Changes user expression into executable code
;
;	in	esi - text pointer
;		edi - exec buffer
;	out	dl - finishing char type ( OT_... )
;
;******************************************************************************

proc	CompileSingleExpr uses eax ebx
	push	edi				; Interpret
	mov	edi, O FnBuffer
	mov	[CurrentPrivLevel], 0
	mov	[PrivLevelStack], O PrivLevels
	call	Bracket
	mov	[byte edi], -1
	pop	edi
	jc	lb_2D
	push	esi				; Compile
	push	edx
	mov	esi, O FnBuffer
	xor	edx, edx
	call	EncodeExpr
	jc	lb_2D1
	pop	edx
	pop	esi
	cmp	[BooleanFlag], 0		; Remove result from stack
	jnz	lb_2D
	mov	eax, O RemoveResult
	call	SendToExecBuf
lb_2D:	ret
lb_2D1:	pop	esi
	pop	esi
	jmp	lb_2D
endp

;******************************************************************************
;
;	CompileMultipleExpr	Changes user expression chain into exec code
;
;	in	esi - text pointer
;		edi - exec buffer
;	out	dl - finishing char type ( OT_... )
;		cf  - (bool)error
;			dl  - error code
;			ebx - start of wrong expression
;			esi - after end of wrong expression
;	destr	ebx
;
;******************************************************************************

proc	CompileMultipleExpr
lb_2E:	mov	ebx, esi			; Determine expression type
	call	DecodeOper
	jc	lb_30
	cmp	dh, ET_CLOSE
	jz	lb_34
	cmp	dl, OT_VALUE
	jz	lb_33
	test	dh, ET_WRITABLE
	jnz	lb_31
	cmp	dl, OT_RESERVED
	jz	lb_35
	cmp	dl, OT_WBOPEN
	jz	lb_32
	mov	dl, ERR_EXPRXP
lb_2F:	stc
lb_30:	ret

lb_31:	call	DecodeOper			; Normal expression
	jc	lb_30
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_OPRAXP
	jnz	lb_2F
	cmp	al, OPR_A
	jc	lb_2F
	mov	esi, ebx
	call	CompileSingleExpr
	jc	lb_30
	cmp	dl, OT_END1
	jz	lb_2E
	clc
	jmp	lb_30

lb_32:	call	CompileMultipleExpr		; Subexpressions
	jc	lb_30
	cmp	dl, OT_WBCLOSE
	jz	lb_2E
	mov	dl, ERR_WBCLOSEXP
	jmp	lb_2F

lb_33:	mov	ebx, eax			; Value assignment
	call	DecodeOper				; val = number;
	jc	lb_30
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_OPRAXP
	jnz	lb_2F
	cmp	al, OPR_A
	jnz	lb_2F
	call	DecodeOper				; number
	jc	lb_30
	mov	cl, 0
	cmp	dl, OT_NUMBER
	jz	lb_331
	cmp	dl, OT_OPERATOR
	mov	dl, ERR_NUMBERXP
	jnz	lb_2F
	cmp	al, OPR_SUB
	jnz	lb_2F
	mov	cl, 1
	call	DecodeOper
	jc	lb_30
	cmp	dl, OT_NUMBER
	mov	dl, ERR_NUMBERXP
	jnz	lb_2F
lb_331:	call	DecodeOper				; semicolon
	jc	lb_30
	cmp	dh, ET_CLOSE
	mov	dl, ERR_SEMICXP
	jnz	lb_2F
	mov	eax, O NumTableEnd			; assign number
	sub	[dword eax], 10
	mov	eax, [eax]
	fld	[tbyte eax]
	cmp	cl, 0
	jz	lb_332
	fchs
lb_332:	fstp	[tbyte eax]
	jmp	lb_2E

lb_34:	cmp	dl, OT_END1			; End sign or ';'
	jz	lb_2E
	clc
	jmp	lb_30

lb_35:	mov	dl, ERR_EXPRXP			; Reserved word
	cmp	al, LASTRESERVED
	ja	lb_2F
	cmp	al, RES_ELSE
	jz	lb_2F
	jmp	[ResWords+eax*4]

res_if:
	call	StartBlockExpr
	jc	lb_30
	call	CompileCommonConditional, 0	; if ~(S)~ E
	jc	lb_30
	call	CompileSingleOrMultiple		; if (S) ~E~
	jc	lb_30
	cmp	dl, OT_WBCLOSE
	jnz	lb_37
	call	DecodeOper
	jc	lb_30
lb_37:	cmp	dl, OT_END1
	mov	dl, ERR_SEMICXP
	jnz	lb_2F
	push	esi				; if (S) E ~else~ E
	call	DecodeOper
	mov	dh, al
	pop	eax
	jc	lb_30
	cmp	dl, OT_RESERVED
	jnz	lb_38
	cmp	dh, RES_ELSE
	jz	lb_39
lb_38:	mov	esi, eax
	call	RealizeConditional
	jmp	lb_3A
lb_39:	call	AddBreak, 1
	jc	lb_30
	call	RealizeConditional
	call	CompileSingleOrMultiple		; if (S) E else ~E~
	jc	lb_30
lb_3A:	call	FinishBlockExpr
	jmp	lb_2E

res_while:
	call	StartBlockExpr
	jc	lb_30
	call	CompileCommonConditional, 0	; while ~(S)~ E
	jc	lb_30
	call	CompileSingleOrMultiple		; while (S) ~E~
	jc	lb_30
	call	AddBreak, 0
	jc	lb_30
	call	RealizeConditional
	call	FinishBlockExpr
	jmp	lb_2E

res_do:
	call	StartBlockExpr
	jc	lb_30
	call	RealizeConditional
	call	CompileSingleOrMultiple		; do ~E~ while (S)
	jc	lb_30
	call	DecodeOper			; do E ~while~ (S)
	jc	lb_30
	cmp	dl, OT_RESERVED
	mov	dl, ERR_WHILEXP
	jnz	lb_2F
	cmp	al, RES_WHILE
	jnz	lb_2F
	call	CompileCommonConditional, 1	; do E while ~(S)~
	jc	lb_30
	call	FinishBlockExpr
	jmp	lb_2E

res_for:
	call	DecodeOper			; for ~(~M,S,M) E;
	jc	lb_30
	cmp	dl, OT_SBOPEN
	mov	dl, ERR_SBOPENXP
	jnz	lb_2F
	call	CompileMultipleExpr		; for (~M,~S,M) E;
	jc	lb_30
	cmp	dl, OT_END2
	mov	dl, ERR_COMMAXP
	jnz	lb_2F
	call	AddJump
	jc	lb_30
	push	eax
	call	StartBlockExpr
	jc	lb_3F
	mov	[BooleanFlag], 1		; for (M,~S,~M) E;
	call	CompileSingleExpr
	mov	[BooleanFlag], 0
	jc	lb_3F
	cmp	dl, OT_END2
	mov	dl, ERR_COMMAXP
	jnz	lb_3F
	call	AddConditionalJump, 0
	jc	lb_3F
	call	AddJump
	jc	lb_3F
	push	eax
	push	edi
	call	CompileMultipleExpr		; for (M,S,~M)~ E;
	jc	lb_3E
	cmp	dl, OT_SBCLOSE
	mov	dl, ERR_SBCLOSEXP
	jnz	lb_3E
	call	AddBreak, 0
	jc	lb_3E
	pop	edx
	pop	eax
	mov	[eax], edi
	pop	eax
	mov	[eax], edi
	push	edx
	call	CompileSingleOrMultiple		; for (M,S,M) ~E~;
	jc	lb_3F
	call	AddJump
	jc	lb_3F
	pop	[dword eax]
	call	RealizeConditional
	call	FinishBlockExpr
	jmp	lb_2E
lb_3E:	pop	eax
	pop	eax
lb_3F:	pop	eax
	jmp	lb_2F

res_break:
	call	AddBreak, 1			; break
	jnc	lb_2E
	ret

res_return:
	xor	eax, eax			; return
	call	SendToExecBuf
	jnc	lb_2E
	ret

res_main:
	cmp	[BlockStart], 0			; main
	mov	dl, ERR_MAININ
	jnz	lb_2F
	cmp	[MainAddr], 0
	mov	dl, ERR_SECONDMAIN
	jnz	lb_2F
	xor	eax, eax
	call	SendToExecBuf
	jc	lb_30
	mov	[MainAddr], edi
	jmp	lb_2E
endp

proc	AddBreak uses eax ecx, BEnd
	cmp	[BlockStart], 0
	jz	lb_421
	call	AddJump
	jc	lb_422
	cmp	[BEnd], 0
	jz	lb_42
	mov	ecx, [BreakTableEnd]
	cmp	ecx, [MaxBreakTableEnd]
	jnc	lb_423
	mov	[ecx], eax
	add	[BreakTableEnd], 4
	ret
lb_42:	mov	ecx, [BlockStart]
	mov	ecx, [ecx]
	mov	[eax], ecx
	ret
lb_423:	mov	dl, ERR_TMANYBREAKS
	jmp	lb_422
lb_421:	mov	dl, ERR_BREAKOUT
	stc
lb_422:	ret
endp

proc	AddJump
	mov	eax, O JumpCode
	call	SendToExecBuf
	jc	lb_424
	mov	eax, edi
	call	SendToExecBuf
lb_424:	ret
endp

proc	CompileSingleOrMultiple uses eax
	push	esi
	call	DecodeOper
	pop	eax
	jc	lb_43
	cmp	dl, OT_WBOPEN
	jz	lb_44

	mov	esi, eax
	call	CompileSingleExpr

lb_43:	ret

lb_44:	call	CompileMultipleExpr
	jc	lb_43
	cmp	dl, OT_WBCLOSE
	jz	lb_43
	cmp	dl, OT_END1
	mov	dl, ERR_WBCLOSEXP
	stc
	jnz	lb_43
	call	DecodeOper
	jc	lb_43
	cmp	dl, OT_WBCLOSE
	jz	lb_43
	mov	dl, ERR_WBCLOSEXP
	stc
	ret
endp

proc	AddConditionalJump uses eax ecx, Bool
	cmp	edi, [MaxExecBuf]
	jc	lb_451
	mov	dl, ERR_EXECBUFOVER
	stc
	ret
lb_451:	mov	eax, O TrueCode
	cmp	[Bool], 0
	jnz	lb_45
	mov	eax, O FalseCode
lb_45:	stosd
	mov	eax, edi
	stosd
	mov	ecx, [BlockStart]
	mov	[ecx+4], eax
	clc
	ret
endp

proc	CompileCommonConditional, Bool
	call	DecodeOper
	jc	lb_46
	cmp	dl, OT_SBOPEN
	mov	dl, ERR_SBOPENXP
	jnz	lb_46
	mov	[BooleanFlag], 1
	call	CompileSingleExpr
	mov	[BooleanFlag], 0
	jc	lb_46
	cmp	dl, OT_SBCLOSE
	mov	dl, ERR_SBCLOSEXP
	jnz	lb_46
	call	AddConditionalJump, [Bool]
	ret
lb_46:	stc
	ret
endp

proc	SendToExecBuf
	cmp	edi, [MaxExecBuf]
	cmc
	jnc	lb_462
	mov	dl, ERR_EXECBUFOVER
	ret
lb_462:	stosd
	ret
endp

proc	RealizeConditional uses eax
	mov	eax, [BlockStart]
	mov	[eax+8], edi
	ret
endp

proc	StartBlockExpr uses eax ecx
	mov	eax, [BlockStart]
	mov	ecx, [BreakTableEnd]
	cmp	ecx, [MaxBreakTableEnd]
	mov	dl, ERR_TMANYBLOCKS
	cmc
	jc	lb_461
	mov	[ecx], eax
	lea	eax, [ecx+4]
	mov	[BlockStart], eax
	mov	[eax], edi
	xor	ecx, ecx
	mov	[eax+4], ecx
	mov	[eax+8], ecx
	add	eax, 12
	mov	[BreakTableEnd], eax
lb_461:	ret
endp

proc	FinishBlockExpr uses eax ecx edx
	mov	eax, [BlockStart]
	mov	ecx, [eax+4]
	mov	edx, [eax+8]
	mov	[ecx], edx
	add	eax, 12
	mov	ecx, [BreakTableEnd]
lb_47:	cmp	eax, ecx
	jnc	lb_48
	mov	edx, [eax]
	mov	[edx], edi
	add	eax, 4
	jmp	lb_47
lb_48:	mov	eax, [BlockStart]
	sub	eax, 4
	mov	[BreakTableEnd], eax
	mov	eax, [eax]
	mov	[BlockStart], eax
	ret
endp

;******************************************************************************
;
;	ExecutableCode		Code that really will be executed
;
;******************************************************************************

proc	ExecutableCode
opr_add:
	call	DoubleArg
	faddp	st(1), st
opr_null:
	ret
opr_sub:
	call	DoubleArg
	fsubp	st(1), st
	ret
opr_mul:
	call	DoubleArg
	fmulp	st(1), st
	ret
opr_div:
	call	DoubleArg
	call	ZeroCheck
	jc	opr_error
	fdivp	st(1), st
	ret
opr_mod:
	call	DoubleArg
	call	ZeroCheck
	jc	opr_error
	call	IntegerCheck
	jc	opr_error
	fxch	st(1)
	fprem
	fstp	st(1)
	ret
opr_pwr:
	call	DoubleArg
	fxch	st(1)
	call	PositiveCheck
	jc	opr_error
	fyl2x
	call	f2x
	ret
opr_shl:
	call	DoubleArg
	fxch	st(1)
	fscale
	fstp	st(1)
	ret
opr_shr:
	call	DoubleArg
	fchs
	jmp	opr_shl
opr_l:
	call	DoubleArg
	fcompp
	fstsw	ax
	test	ah, 45h
	jz	opr_true
	jmp	opr_false
opr_g:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 01h
	jz	opr_true
	jmp	opr_false
opr_e:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	opr_true
	jmp	opr_false
opr_le:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 01h
	jnz	opr_true
	jmp	opr_false
opr_ge:
	call	DoubleArg
	fcompp
	fstsw	ax
	test	ah, 45h
	jnz	opr_true
	jmp	opr_false
opr_ne:
	call	DoubleArg
	fcompp
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_and:
	call	DoubleArg
	fcomp	st(1)
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4A
	ffree	st
	fincstp
	jmp	opr_false
lb_4A:	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_or:
	call	DoubleArg
	fcomp	st(1)
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4B
	ffree	st
	fincstp
	jmp	opr_true
lb_4B:	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jnz	opr_true
	jmp	opr_false
opr_true:
	fld1
	ret
opr_false:
	fldz
	ret

opr_neg:
	call	SingleArg
	fchs
	ret
opr_abs:
	call	SingleArg
	fabs
	ret
opr_sin:
	call	SingleArg
	fsin
	ret
opr_cos:
	call	SingleArg
	fcos
	ret
opr_atan:
	call	SingleArg
	fld1
	fpatan
	ret
opr_log:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	ret
opr_ln:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	fldl2e
	fdivp	st(1), st
	ret
opr_lg:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fld1
	fxch	st(1)
	fyl2x
	fldl2t
	fdivp	st(1), st
	ret
opr_sqrt:
	call	SingleArg
	call	PositiveCheck
	jc	opr_error
	fsqrt
	ret
opr_frac:
	call	SingleArg
	fld	st
	frndint
	fsubp	st(1), st
	ret
opr_exp:
	call	SingleArg
	fldl2e
	fmulp	st(1), st
	call	f2x
	fstp	[tbyte edi]
	ret
opr_error:
	fninit
	add	esp, 4
	stc
	ret
endp

proc	SingleArg
	mov	eax, O StackTop
	sub	[dword eax], 10
	mov	eax, [eax]
	fld	[tbyte eax]
;	pop	eax
	pop	ax
	push	O EndOper
;	jmp	eax
	jmp	ax
endp

proc	DoubleArg
	mov	eax, [StackTop]
	sub	eax, 20
	fld	[tbyte eax]
	fld	[tbyte eax+10]
	mov	[StackTop], eax
;	pop	eax
	pop	ax
	push	O EndOper
;	jmp	eax
	jmp	ax
endp

proc	EndOper
	mov	eax, [StackTop]
	add	[StackTop], 10
	fstp	[tbyte eax]
	ret
endp

proc	RemoveResult
	sub	[StackTop], 10
	ret
endp

proc	f2x
	fld	st
	frndint
	fsub	st(1), st
	fld1
	fscale
	fstp	st(1)
	fxch	st(1)
	f2xm1
	fld1
	faddp	st(1), st
	fmulp	st(1), st
	ret
endp

proc	PositiveCheck
	cmp	[FriendlySyntax], 0
	jnz	lb_4D
	fxam
	fstsw	ax
	test	ah, 02h
	jz	lb_4E
	mov	al, ERR_NEGATIVEVAL
	stc
	ret
lb_4D:	fabs
lb_4E:	ret
endp

proc	ZeroCheck
	ftst
	fstsw	ax
	and	ah, 45h
	cmp	ah, 40h
	clc
	jnz	lb_4E
	cmp	[FriendlySyntax], 0
	jnz	lb_4F
	mov	al, ERR_DIVBYZERO
	stc
	ret
lb_4F:	ffree	st
	fincstp
	fld	st
	ret
endp

proc	IntegerCheck
	cmp	[FriendlySyntax], 0
	clc
	jnz	lb_4E
	fld	st
	frndint
	fsubr	st, st(1)
	ftst
	fstsw	ax
	ffree	st
	fincstp
	and	ah, 45h
	cmp	ah, 40h
	jz	lb_4E
	mov	al, ERR_INTEGERXP
	stc
	ret
endp

proc	StoreVar
	lodsd
	mov	edi, eax
	push	esi
	mov	esi, [StackTop]
	mov	ecx, 10
	sub	esi, ecx
	rep	movsb
	pop	esi
	clc
	ret
endp

proc	LoadVar
	mov	edi, [StackTop]
	cmp	edi, [MaxStackTop]
	mov	dl, ERR_STACKOVER
	cmc
	jc	lb_4F2
	lodsd
	push	esi
	mov	esi, eax
	mov	ecx, 5
	rep	movsw
	mov	[StackTop], edi
	pop	esi
lb_4F2:	ret
endp

proc	JumpCode
	lodsd
	mov	esi, eax
	clc
	ret
endp

proc	GetBoolResult
	mov	edi, O StackTop
	mov	ecx, 10
	sub	[edi], ecx
	mov	edi, [edi]
	mov	al, 0
	repz	scasb
	setnz	al
	shr	al, 1
	lodsd
	ret
endp

proc	TrueCode
	call	GetBoolResult
	jnc	lb_4F1
	mov	esi, eax
lb_4F1:	clc
	ret
endp

proc	FalseCode
	call	GetBoolResult
	jc	lb_4F1
	mov	esi, eax
	ret
endp

;******************************************************************************
;
;	Compile		Main function that compiles all expressions
;
;	in	esi - address of buffer to be compiled
;	out	cf  - (bool)error
;			dl - error code
;
;******************************************************************************

proc	Compile uses es
	push	ds
	pop	es
	push	esi
	push	ecx

	mov	esi, O StdOpers			; Fill initial Opers buffer
	mov	edi, [Opers]
	mov	ecx, O StdOpersEnd - O StdOpers
	cld
	rep	movsb

	mov	[NumTableEnd], O NumTable	; Prepare to compilation
	mov	[MainAddr], 0
	mov	[BlockStart], 0
	mov	[BreakTableEnd], O BreakTable
	mov	[BooleanFlag], 0
	pop	ecx
	pop	esi
	mov	edi, O ExecBuffer

lb_50:	call	CompileMultipleExpr		; Compile
	jc	lb_51
	cmp	dl, OT_EOF
	jz	lb_51
	cmp	dl, OT_END1
	jz	lb_50
	mov	dl, ERR_SEMICXP
	stc

lb_51:	mov	[dword edi], 0
	ret
endp

;******************************************************************************
;
;	Execute		Executes function (initial or main)
;		Initial: 0 - main code, 1 - initial code
;
;	out	cf  - (bool)error
;			dl - error code
;
;******************************************************************************

proc	Execute uses es esi eax, Initial
	fninit
	push	eax
	fstcw	[esp]
	and	[byte esp+1], 0F3h
	or	[byte esp+1], 04h
	fldcw	[esp]
	pop	eax
	push	ds
	pop	es
	mov	[StackTop], O ExecStack
	cld
	mov	esi, O ExecBuffer
	cmp	[Initial], 0
	jz	lb_52
	cmp	[MainAddr], 0
	jnz	lb_53
	ret
lb_52:	cmp	[MainAddr], 0
	jz	lb_53
	mov	esi, [MainAddr]
lb_53:	lodsd
	or	eax, eax
	jz	lb_54
	call	eax
	jc	lb_54
	jmp	lb_53
lb_54:	ret
endp

proc	main
	mov	ax, @data
	mov	ds, ax
	mov	es, ax
	mov	ss, ax
	mov	sp, O StackPtr
	mov	esi, O UserCode
	mov	[UserBufferEnd], O UserCodeEnd
	call	Compile
	call	Execute, 0
	mov	ah, 4Ch
	int	21h
endp

end main