;***********************************************
;		     ! " # $ % & ' ( ) * + , - .  /
SignTypes	db 0,3,0,0,0,3,3,0,4,5,3,3,9,3,17,3
		db 10 dup (17)				; 0..9
;		   : ; < = > ? @
		db 0,8,3,3,3,0,0
		db 26 dup (1)				; A..Z
;		   [ \ ] ^ _ `
		db 0,0,0,3,1,0
		db 26 dup (1)				; a..z
;		   { | } ~
		db 6,3,7,0,0
;***********************************************
ExTypes		db 3,1,4,8,16,8,16,16,16,16,0,8,1,2,-1,-1,2
;***********************************************
;		      + - * / % ^ << >>
OpLevels	db -1,4,4,5,5,5,6,5, 5
;		   < > == <= >= != && ||
		db 3,3,3, 3, 3, 3, 2, 2
		db 11 dup (0)	; functions
;		=,+=,-=,*=,/=,%=,^=,<<=,>>=
		db 9 dup (0)
;***********************************************
OpAddr		dd O opr_null, O opr_add, O opr_sub, O opr_mul	; '',+,-,*
		dd O opr_div, O opr_mod, O opr_pwr, O opr_shl	; /,%,^,<<
		dd O opr_shr, O opr_l, O opr_g, O opr_e		; >>,<,>,==
		dd O opr_le, O opr_ge, O opr_ne, O opr_and	; <=,>=,!=,&&
		dd O opr_or, O opr_neg, O opr_abs, O opr_sin	; ||,-a,abs,sin
		dd O opr_cos, O opr_atan, O opr_log, O opr_ln
		dd O opr_lg, O opr_sqrt, O opr_frac, O opr_exp
		dd O opr_null, O opr_add, O opr_sub, O opr_mul	; =,+=,-=,*=
		dd O opr_div, O opr_mod, O opr_pwr, O opr_shl, O opr_shr
;***********************************************
StdOpers	db 1, '+', OT_OPERATOR, OPR_ADD, 0, 0, 0
		db 1, '-', OT_OPERATOR, OPR_SUB, 0, 0, 0
		db 1, '*', OT_OPERATOR, OPR_MUL, 0, 0, 0
		db 1, '/', OT_OPERATOR, OPR_DIV, 0, 0, 0
		db 1, '%', OT_OPERATOR, OPR_MOD, 0, 0, 0
		db 1, '^', OT_OPERATOR, OPR_PWR, 0, 0, 0
		db 2, '<<', OT_OPERATOR, OPR_SHL, 0, 0, 0
		db 2, '>>', OT_OPERATOR, OPR_SHR, 0, 0, 0
		db 1, '<', OT_OPERATOR, OPR_L, 0, 0, 0
		db 1, '>', OT_OPERATOR, OPR_G, 0, 0, 0
		db 2, '==', OT_OPERATOR, OPR_E, 0, 0, 0
		db 2, '<=', OT_OPERATOR, OPR_LE, 0, 0, 0
		db 2, '>=', OT_OPERATOR, OPR_GE, 0, 0, 0
		db 2, '!=', OT_OPERATOR, OPR_NE, 0, 0, 0
		db 2, '&&', OT_OPERATOR, OPR_AND, 0, 0, 0
		db 2, '||', OT_OPERATOR, OPR_OR, 0, 0, 0

		db 3, 'abs', OT_FUN, OPR_ABS, 0, 0, 0
		db 3, 'sin', OT_FUN, OPR_SIN, 0, 0, 0
		db 3, 'cos', OT_FUN, OPR_COS, 0, 0, 0
		db 4, 'atan', OT_FUN, OPR_ATAN, 0, 0, 0
		db 3, 'log', OT_FUN, OPR_LOG, 0, 0, 0
		db 2, 'ln', OT_FUN, OPR_LN, 0, 0, 0
		db 2, 'lg', OT_FUN, OPR_LG, 0, 0, 0
		db 4, 'sqrt', OT_FUN, OPR_SQRT, 0, 0, 0
		db 4, 'frac', OT_FUN, OPR_FRAC, 0, 0, 0
		db 3, 'exp', OT_FUN, OPR_EXP, 0, 0, 0

		db 1, '=', OT_OPERATOR, OPR_A, 0, 0, 0
		db 2, '+=', OT_OPERATOR, OPR_AADD, 0, 0, 0
		db 2, '-=', OT_OPERATOR, OPR_ASUB, 0, 0, 0
		db 2, '*=', OT_OPERATOR, OPR_AMUL, 0, 0, 0
		db 2, '/=', OT_OPERATOR, OPR_ADIV, 0, 0, 0
		db 2, '%=', OT_OPERATOR, OPR_AMOD, 0, 0, 0
		db 2, '^=', OT_OPERATOR, OPR_APWR, 0, 0, 0
		db 3, '<<=', OT_OPERATOR, OPR_ASHL, 0, 0, 0
		db 3, '>>=', OT_OPERATOR, OPR_ASHR, 0, 0, 0

		db 2, 'if', OT_RESERVED, RES_IF, 0, 0, 0
		db 4, 'else', OT_RESERVED, RES_ELSE, 0, 0, 0
		db 5, 'while', OT_RESERVED, RES_WHILE, 0, 0, 0
		db 2, 'do', OT_RESERVED, RES_DO, 0, 0, 0
		db 3, 'for', OT_RESERVED, RES_FOR, 0, 0, 0
		db 5, 'break', OT_RESERVED, RES_BREAK, 0, 0, 0
		db 6, 'return', OT_RESERVED, RES_RETURN, 0, 0, 0
		db 4, 'main', OT_RESERVED, RES_MAIN, 0, 0, 0

		db 1, 'x', OT_VAR
		dd O X
		db 1, 'y', OT_VAR
		dd O Y
		db 1, 'z', OT_VAR
		dd O Z
		db 1, 'p', OT_CONST
		dd O P
		db 1, 'q', OT_CONST
		dd O Q
		db 1, 't', OT_CONST
		dd O T
		db 2, 'pi', OT_CONST
		dd O ConstPi
		db 1, 'e', OT_CONST
		dd O ConstE
		db 3, 'l2t', OT_CONST
		dd O ConstL2t
		db 3, 'l2e', OT_CONST
		dd O ConstL2e
		db 3, 'ln2', OT_CONST
		dd O ConstLn2
		db 3, 'lg2', OT_CONST
		dd O ConstLg2
		db 4, 'xmid', OT_VALUE
		dd O XMid
		db 4, 'ymid', OT_VALUE
		dd O YMid
		db 4, 'zmid', OT_VALUE
		dd O ZMid
		db 5, 'scale', OT_VALUE
		dd O XYZScale
		db 4, 'pmin', OT_VALUE
		dd O PMin
		db 4, 'pmax', OT_VALUE
		dd O PMax
		db 5, 'pgran', OT_VALUE
		dd O PGran
		db 4, 'qmin', OT_VALUE
		dd O QMin
		db 4, 'qmax', OT_VALUE
		dd O QMax
		db 5, 'qgran', OT_VALUE
		dd O QGran
		db 4, 'tmax', OT_VALUE
		dd O TMax
		db 0
label StdOpersEnd
;***********************************************
Error0		db 'Unknown sign', 0
Error1		db 'Unknown operator/operand', 0
Error2		db 'Invalid number format', 0
Error3		db 'Too many brackets', 0
Error4		db 'Data buffer overflow', 0
Error5		db 'Too many breaks', 0
Error6		db 'Too many block instructions', 0
Error7		db 'Conversion buffer overflow', 0
Error8		db 'Executable buffer overflow', 0
Error9		db 'Operand expected', 0
Error10		db 'Operator expected', 0
Error11		db 'Writable variable expected', 0
Error12		db 'Expression expected', 0
Error13		db 'Number expected', 0
Error14		db '''('' expected', 0
Error15		db ''')'' expected', 0
Error16		db ''';'' expected', 0
Error17		db '''='' expected', 0
Error18		db '''}'' expected', 0
Error19		db ''','' expected', 0
Error20		db '''while'' expected', 0
Error21		db 'Wrong break placement', 0
Error22		db 'Wrong main placement', 0
Error23		db 'Duplicate main label', 0
Error24		db 'Negative value', 0
Error25		db 'Division by zero', 0
Error26		db 'Non-integer value', 0
Error27		db 'Stack overflow', 0
Errors		dd O Error0, O Error1, O Error2, O Error3, O Error4, O Error5
		dd O Error6, O Error7, O Error8, O Error9, O Error10, O Error11
		dd O Error12, O Error13, O Error14, O Error15, O Error16
		dd O Error17, O Error18, O Error19, O Error20, O Error21
		dd O Error22, O Error23, O Error24, O Error25, O Error26, O Error27
;***********************************************
ConstPi		dt 4000C90FDAA22168C235h
ConstE		dt 4000ADF85458A2BB4A9Bh
ConstL2t	dt 4000D49A784BCD1B8AFEh
ConstL2e	dt 3FFFB8AA3B295C17F0BCh
ConstLn2	dt 3FFEB17217F7D1CF79ACh
ConstLg2	dt 3FFD9A209A84FBCFF799h
;***********************************************
ResWords	dd O res_if, 0, O res_while, O res_do, O res_for
		dd O res_break, O res_return, O res_main
;***********************************************
