dataseg

NUMGRIDPOINTS = 44
label Grid3DPoints
	dd -16, -16, 16, -16, -16, -12, 16, -12, -16, -8, 16, -8
	dd -16, -4, 16, -4, -16, 16, 16, 16, -16, 12, 16, 12, -16
	dd 8, 16, 8, -16, 4, 16, 4, -16, -16, -16, 16, -12, -16
	dd -12, 16, -8, -16, -8, 16, -4, -16, -4, 16, 16, -16, 16
	dd 16, 12, -16, 12, 16, 8, -16, 8, 16, 4, -16, 4, 16, -20
	dd 0, 20, 0, 0, -20, 0, 20, 20, 0, 19, 1, 20, 0, 19, -1
	dd 0, 20, 1, 19, 0, 20, -1, 19

udataseg

OriginX		dd ?				; Line drawing constants
OriginY		dd ?
OriginAddr	dd ?
BitmapAddr	dd ?
ColorID		db ?
Grid2DPoints	dq NUMGRIDPOINTS dup (?)

codeseg

proc	UpdateChart
	call	GlobalLock, [hmem3DPoints]
	mov	esi, eax
	call	GlobalLock, [hmem2DPoints]
	push	eax
	mov	edi, eax
	call	GlobalLock, [hmemBitmap]
	mov	[BitmapAddr], eax
	call	XformChart
	pop	esi
	call	[DrawChart]
	call	GlobalUnlock, [hmem3DPoints]
	call	GlobalUnlock, [hmem2DPoints]
	call	GlobalUnlock, [hmemBitmap]
	ret
endp

proc	XformChart uses ebp		; ds:esi (3D), es:edi (2D) - buffers
wsr1		= esp +	0
hsr1		= esp +	4
sina		= dword esp + 8
cosa		= dword esp + 12
sinb		= dword esp + 16
cosb		= dword esp + 20
sinasinb	= esp +	24
sinacosb	= esp +	28
cosasinb	= esp +	32
cosacosb	= esp +	36
dy		= esp +	40
	sub	esp, 4*11

	mov	ebp, [BitmapWidth]		; -k = -wid
	neg	ebp
k = ebp

	mov	eax, [XYZScale]			; dy = 3/2 * XYZScale (real dy)
	lea	eax, [eax+eax*2]
	shl	eax, 9-1
	mov	[dy], eax

	fldpi
	push	-9
	fild	[dword esp]
	add	esp, 4
	fild	[Alpha]				; sina, cosa
	fmul	st, st(2)
	fscale
	fsincos
	fld	st(2)
	fchs
	fxch	st(1)
	fscale
	fistp	[cosa]
	fxch	st(1)
	fscale
	fistp	[sina]
	ffree	st
	fincstp

	fild	[Beta]				; sinb, cosb
	fmul	st, st(2)
	fscale
	fsincos
	fld	st(2)
	fchs
	fxch	st(1)
	fscale
	fistp	[cosb]
	fxch	st(1)
	fscale
	fistp	[sinb]
	ffree	st
	fincstp
	ffree	st
	fincstp
	ffree	st

	mov	eax, [sina]			; sinasinb
	mov	ebx, eax
	imul	[sinb]
	shrd	eax, edx, 8
	shl	edx, 1
	rcr	eax, 1
	imul	k
	mov	[sinasinb], eax

	mov	eax, ebx			; sinacosb
	imul	[cosb]
	shrd	eax, edx, 8
	shl	edx, 1
	rcr	eax, 1
	mov	[sinacosb], eax

	mov	eax, [cosa]			; cosasinb
	mov	ebx, eax
	imul	[sinb]
	shrd	eax, edx, 8
	shl	edx, 1
	rcr	eax, 1
	imul	k
	mov	[cosasinb], eax

	mov	eax, ebx			; cosacosb
	imul	[cosb]
	shrd	eax, edx, 8
	shl	edx, 1
	rcr	eax, 1
	mov	[cosacosb], eax

	mov	eax, [cosa]
	imul	k
	neg	eax
	mov	[cosa], eax
	mov	eax, [sina]
	imul	k
	neg	eax
	mov	[sina], eax
	mov	eax, [cosb]
	imul	k
	mov	[cosb], eax

	mov	eax, [BitmapWidth]		; w / 2
	shr	eax, 1
	mov	[wsr1], eax
	mov	eax, [BitmapHeight]		; h / 2
	shr	eax, 1
	mov	[hsr1], eax

	mov	ecx, [PGran]
	imul	ecx, [QGran]
	cld

xp_01:	mov	eax, [esi]
	mov	ebx, [esi+4]
	mov	ebp, [esi+8]
	imul	eax, [sinacosb]			; y'= ((x - hx) * sinacosb +
	imul	ebx, [cosacosb]			;      (y - hy) * cosacosb -
	imul	ebp, [sinb]			;      (z - hz) * sinb) + dy
	add	eax, ebx
	sub	eax, ebp
	add	eax, [dy]
	sar	eax, 7
	jnz	xp_02
	inc	eax
xp_02:	mov	ebp, eax

	mov	eax, [esi]			; x'= ((x - hx) * cosa -
	mov	ebx, [esi+4]			;      (y - hy) * sina)
	imul	eax, [cosa]			; x" = w/2 + k*x'/y'
	imul	ebx, [sina]
	sub	eax, ebx
	cdq
	idiv	ebp
	sar	eax, 7
	add	eax, [wsr1]
	stosd

	mov	eax, [esi]			; z' = ((x - hx) * sinasinb +
	mov	ebx, [esi+4]			;	(y - hy) * cosasinb +
	imul	eax, [sinasinb]			;	(z - hz) * cosb)
	imul	ebx, [cosasinb]			; y" = h/2 - k*z'/y'
	add	eax, ebx
	mov	ebx, [esi+8]
	imul	ebx, [cosb]
	add	eax, ebx
	cdq
	idiv	ebp
	sar	eax, 7
	add	eax, [hsr1]
	stosd

	add	esi, 12
	loop	xp_01

include "grid.inc"

	add	esp, 4*11
	ret
endp

proc	DrawWiredChart			; ds:esi (2D), es:BA (BMP) - buffers
	mov	[ColorID], 2	; wire color id is 2
	push	esi
	mov	ebx, [QGran]
	cld
dl_01:	mov	ecx, [PGran]
	call	ResetLine
dl_02:	lodsd
	mov	edx, eax
	lodsd
	xchg	edx, eax
	push	ebx
	push	ecx
	push	esi
	call	LineTo
	pop	esi
	pop	ecx
	pop	ebx
	loop	dl_02
	dec	ebx
	jnz	dl_01

	pop	esi
	mov	ebx, [PGran]
	mov	edi, ebx
	shl	edi, 3
dl_03:	mov	ecx, [QGran]
	push	esi
	call	ResetLine
dl_04:	mov	eax, [esi]
	mov	edx, [esi+4]
	push	ebx
	push	ecx
	push	esi
	push	edi
	call	LineTo
	pop	edi
	pop	esi
	pop	ecx
	pop	ebx
	add	esi, edi
	loop	dl_04
	pop	esi
	add	esi, 8
	dec	ebx
	jnz	dl_03

	ret
endp

proc	ResetLine
	mov	[OriginX], 80000000h
	ret
endp

_X1 = ebx
_Y1 = ecx
_X2 = esi
_Y2 = edi
_dX = eax
_dY = edx

macro	linedata
	mov	ecx, esi
	inc	ecx
	mov	ebx, esi
	neg	ebx
	shl	edx, 2
	shl	esi, 2
endm

proc	LineTo uses ebp				; eax = x, edx = y
	cmp	[OriginX], 80000000h		; Check Origin
	jnz	ln_03

ln_01:	mov	[OriginX], eax			; Move cursor
	mov	[OriginY], edx
	imul	edx, [BitmapWidth]
	add	edx, eax
	add	edx, [BitmapAddr]
	mov	[OriginAddr], edx
ln_02:	ret

ln_03:	mov	ebx, [OriginX]			; Get X1, Y1
	mov	ecx, [OriginY]
	mov	[OriginX], eax
	mov	[OriginY], edx
	mov	esi, eax
	mov	edi, edx

	mov	_dX, [BitmapWidth]		; Check if whole line is visible
	mov	_dY, [BitmapHeight]
	xor	ebp, ebp
	test	_X1, _X1			; X1 < 0
	js	ln_09
	cmp	_X1, _dX			; X1 >= BitmapWidth
	jnl	ln_0A
ln_04:	test	_X2, _X2			; X2 < 0
	js	ln_0B
ln_05:	cmp	_X2, _dX			; X2 >= BitmapWidth
	jnl	ln_0C
ln_06:	test	_Y1, _Y1			; Y1 < 0
	js	ln_0D
	cmp	_Y1, _dY			; Y1 >= BitmapHeight
	jnl	ln_0E
ln_07:	test	_Y2, _Y2			; Y2 < 0
	js	ln_0F
ln_08:	cmp	_Y2, _dY			; Y2 >= BitmapHeight
	jl	ln_11
	jmp	ln_10

ln_09:	test	_X2, _X2			; X1 < 0
	js	ln_02
	push	esi
	push	edi
	sub	esi, _X1
	sub	edi, _Y1
	mov	eax, _X1
	neg	eax
	imul	edi
	idiv	esi
	pop	edi
	pop	esi
	add	_Y1, eax
	xor	_X1, _X1
	inc	ebp
	mov	_dX, [BitmapWidth]
	mov	_dY, [BitmapHeight]
	jmp	ln_05

ln_0A:	cmp	_X2, _dX			; X1 >= BitmapWidth
	jnl	ln_02
	push	esi
	push	edi
	sub	esi, _X1
	sub	edi, _Y1
	sub	eax, _X1
	dec	eax
	imul	edi
	idiv	esi
	pop	edi
	pop	esi
	add	_Y1, eax
	mov	_X1, [BitmapWidth]
	mov	_dX, _X1
	dec	_X1
	mov	_dY, [BitmapHeight]
	inc	ebp
	jmp	ln_04

ln_0B:	push	ebx				; X2 < 0
	push	ecx
	sub	ebx, _X2
	neg	ebx
	sub	ecx, _Y2
	neg	ecx
	mov	eax, _X2
	neg	eax
	imul	ecx
	idiv	ebx
	pop	ecx
	pop	ebx
	add	_Y2, eax
	xor	_X2, _X2
	mov	_dX, [BitmapWidth]
	mov	_dY, [BitmapHeight]
	jmp	ln_06

ln_0C:	push	ebx				; X2 >= BitmapWidth
	push	ecx
	sub	ebx, _X2
	neg	ebx
	sub	ecx, _Y2
	neg	ecx
	sub	eax, _X2
	dec	eax
	imul	ecx
	idiv	ebx
	pop	ecx
	pop	ebx
	add	_Y2, eax
	mov	_X2, [BitmapWidth]
	mov	_dX, _X2
	dec	_X2
	mov	_dY, [BitmapHeight]
	jmp	ln_06

ln_0D:	test	_Y2, _Y2			; Y1 < 0
	js	ln_02
	push	esi
	push	edi
	sub	esi, _X1
	sub	edi, _Y1
	mov	eax, _Y1
	neg	eax
	imul	esi
	idiv	edi
	pop	edi
	pop	esi
	add	_X1, eax
	xor	_Y1, _Y1
	inc	ebp
	mov	_dX, [BitmapWidth]
	mov	_dY, [BitmapHeight]
	jmp	ln_08

ln_0E:	cmp	_Y2, _dY			; Y1 >= BitmapWidth
	jnl	ln_02
	push	esi
	push	edi
	sub	esi, _X1
	sub	edi, _Y1
	mov	eax, edx
	sub	eax, _Y1
	dec	eax
	imul	esi
	idiv	edi
	pop	edi
	pop	esi
	add	_X1, eax
	mov	_Y1, [BitmapHeight]
	mov	_dY, _Y1
	dec	_Y1
	mov	_dX, [BitmapWidth]
	inc	ebp
	jmp	ln_07

ln_0F:	push	ebx				; Y2 < 0
	push	ecx
	sub	ebx, _X2
	neg	ebx
	sub	ecx, _Y2
	neg	ecx
	mov	eax, _Y2
	neg	eax
	imul	ebx
	idiv	ecx
	pop	ecx
	pop	ebx
	add	_X2, eax
	xor	_Y2, _Y2
	jmp	ln_11

ln_10:	push	ebx				; Y2 >= BitmapWidth
	push	ecx
	sub	ebx, _X2
	neg	ebx
	sub	ecx, _Y2
	neg	ecx
	mov	eax, edx
	sub	eax, _Y2
	dec	eax
	imul	ebx
	idiv	ecx
	pop	ecx
	pop	ebx
	add	_X2, eax
	mov	_Y2, [BitmapHeight]
	dec	_Y2

ln_11:	test	ebp, ebp			; Update origin address
	jz	ln_12
	mov	eax, _Y1
	imul	eax, [BitmapWidth]
	add	eax, _X1
	add	eax, [BitmapAddr]
	mov	[OriginAddr], eax

ln_12:	mov	ebp, [BitmapWidth]		; Calc delta Y
	sub	_Y2, _Y1
	jnc	ln_13
	neg	_Y2
	neg	ebp
ln_13:	mov	edx, edi
	mov	edi, [OriginAddr]
	mov	al, [ColorID]

	sub	_X2, _X1
	jc	ln_19
	cmp	esi, edx
	jc	ln_16
	linedata
	jmp	ln_15
ln_14:	inc	edi				; x++
	add	ebx, edx			; A += 2*dY
	js	ln_15
	sub	ebx, esi			; A -= 2*dX
	add	edi, ebp			; y++
ln_15:	mov	[edi], al			; PutPixel (x, y)
	loop	ln_14
	jmp	ln_1F

ln_16:	xchg	esi, edx
	linedata
	jmp	ln_18
ln_17:	add	edi, ebp			; y++
	add	ebx, edx			; A += 2*dY
	js	ln_18
	sub	ebx, esi			; A -= 2*dX
	inc	edi				; x++
ln_18:	mov	[edi], al			; PutPixel (x, y)
	loop	ln_17
	jmp	ln_1F

ln_19:	neg	esi
	cmp	esi, edx
	jc	ln_1C
	linedata
	jmp	ln_1B
ln_1A:	dec	edi				; x--
	add	ebx, edx			; A += 2*dY
	js	ln_1B
	sub	ebx, esi			; A -= 2*dX
	add	edi, ebp			; y++
ln_1B:	mov	[edi], al			; PutPixel (x, y)
	loop	ln_1A
	jmp	ln_1F

ln_1C:	xchg	esi, edx
	linedata
	jmp	ln_1E
ln_1D:	add	edi, ebp			; y++
	add	ebx, edx			; A += 2*dY
	js	ln_1E
	sub	ebx, esi			; A -= 2*dX
	dec	edi				; x--
ln_1E:	mov	[edi], al			; PutPixel (x, y)
	loop	ln_1D

ln_1F:	mov	[OriginAddr], edi
	ret
endp
